c
c     subroutines for Monte Carlo/optional bias program Biasmc 
c
c     ------------------------------------------------------
      subroutine retopo
c     read topology file  unit 2
      implicit real*8 (a-h,o-z)
      integer*1 isy,isysav
      character*2 head1,head2,symbol
      dimension xdum(6),idum(6),savef(100,3),savet(3),chu(100),chv(100),
     1 ispu(100),ispv(100) 
      common /symb/ head1(10),head2(10)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100) 
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
c     intramolecular energy parameters
      common /intraf/ rzeu(50),fkstru(50),tzeu(50),fkbndu(50),
     1rzev(50),fkstrv(50),tzev(50),fkbndv(50),
     2fktrsu(30),fasu(30),ftru(20),fktrsv(30),fasv(30),ftrv(30),
     3ebondu(2000),ebondv(2000)
      common /intrai/nstru,istru(50,2),nbendu,ibendu(50,3),
     1 nstrv,istrv(50,2),nbendv,ibendv(50,3),
     2 ntorsu,itorsu(30,4),nblstu(1000,2),
     3 nlistu,ntorsv,itorsv(30,4),nblstv(1000,2),nlistv
c     potential tables
      common/potato/ ptu(100,100,3),ptv(100,100,3),ptuv(100,100,3),
     1 deru(100,100,3),derv(100,100,3),deruv(100,100,3),fq,fp,fd,fr
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
      ntyp=70
      read(2,1) (head2(k),k=1,10)
   1  format(10a2)
      write(3,6) (head2(k),k=1,10)
   6  format(' topology file header line',/2x,10a2,/)
      ridic=0.0001
      read(2,*) ncoreu
      write(3,51) 
 51   format(' core atoms, solute')
c     read solute core atom coordinates
      do 7 i=1,ncoreu
      read(2,*) nx,ax,bx,cx,isx,qx
      xcore(nx,1)=ax
      xcore(nx,2)=bx
      xcore(nx,3)=cx
      qq(nx)=qx
      ww(nx)=wei(isx)
      isp(nx)=isx
  7   write(3,8) nx,(xcore(nx,kk),kk=1,3),isp(nx),qq(nx)
  8   format(i6,3f10.4,i5,f8.4)
      nslavu=0
      read(2,*) ncardu
      if(ncardu.eq.0) go to 9
c     read solute slave atom cards
      write(3,52)
 52   format(' slave atoms,solute: trailers,species,charge')
      do 10 i=1,ncardu
      read(2,*) (idum(k),k=1,6),isx,qx
      write(3,11) (idum(k),k=1,6),isx,qx
  11  format(i5,5i4,i6,f10.4)
      do 12 j=1,6
  12  islav(i,j)=idum(j)
      if(idum(2).le.0) nslavu=nslavu+1
      if(idum(2).gt.0.and.idum(3).eq.0) nslavu=nslavu+2 
      if(idum(2).gt.0.and.idum(3).ne.0) nslavu=nslavu+3 
c     assign parameters to slave atoms 
      nx=idum(1)
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
      nx=idum(2)
      if(nx.le.0) go to 13
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
      nx=idum(3)
      if(nx.le.0) go to 13
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
  13  continue
  10  continue
   9  continue
      nasolu=ncoreu+nslavu
      write(3,14) nasolu,ncoreu,nslavu
   14 format(/' solute atoms,total,core,slaves',3i5)
      nasolv=0
      nslavv=0
      read(2,*) ncorev
      if(ncorev.eq.0) go to 420
c     read core atom coordinates (solvent)
      write(3,53)
 53   format(' core atoms, solvent')
      do 407 i=1,ncorev
      read(2,*) nx,ax,bx,cx,isx,qx
      nx1=nx+nasolu
      xcore(nx1,1)=ax
      xcore(nx1,2)=bx
      xcore(nx1,3)=cx
      qq(nx1)=qx
      ww(nx1)=wei(isx)
      isp(nx1)=isx
 407  write(3,408) nx,(xcore(nx1,kk),kk=1,3),isp(nx1),qq(nx1)
 408  format(i6,3f10.4,i5,f8.4)
 420  read(2,*) ncardv
      if(ncardv.eq.0) go to 401
c     read solvent slave atom cards
      write(3,54)
 54   format(' slave atoms,solvent: trailers, species, charge')
      do 410 i=1,ncardv
      read(2,*) (idum(k),k=1,6),isx,qx
      write(3,11) (idum(k),k=1,6),isx,qx
      ip=i+ncardu
      do 412 j=1,6
 412  islav(ip,j)=idum(j)
      if(idum(2).le.0) nslavv=nslavv+1
      if(idum(2).gt.0.and.idum(3).eq.0) nslavv=nslavv+2 
      if(idum(2).gt.0.and.idum(3).ne.0) nslavv=nslavv+3 
c     assign parameters to slave atoms    
      nx=idum(1)+nasolu
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
      if(idum(2).le.0) go to 413
      nx=idum(2)+nasolu
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
      if(idum(3).le.0) go to 413
      nx=idum(3)+nasolu
      isp(nx)=isx
      qq(nx)=qx
      ww(nx)=wei(isx)
 413  continue
 410  continue
 401  continue
c     read molecular volumes
      read(2,*) voluu,voluv
      nasolv=ncorev+nslavv
      write(3,414) nasolv,ncorev,nslavv
 414  format(' solvent atoms,total,core,slaves',3i5)
c --- force field part, read stretch bend torsion parameters ---------
      maxstr=50
      maxbe=50
      maxto=30
      read(2,*) nstru
      if(nstru.gt.maxstr) call emerg (301)
      if(nstru.eq.0) go to 23
      write(3,20) nstru 
  20  format(i5,' stretch functions solute')
      do 21 i=1,nstru
      read(2,*) istru(i,1),istru(i,2),rzeu(i),fkstru(i)
  21  write(3,22) istru(i,1),istru(i,2),rzeu(i),fkstru(i)
  22  format(2i5,2f10.4,2x,5e12.4)
  23  read(2,*) nstrv
      if(nstrv.gt.maxstr) call emerg (301)
      if(nstrv.eq.0) go to 24  
      write(3,25) nstrv 
  25  format(i5,' stretch functions solvent')
      do 26 i=1,nstrv
      read(2,*) istrv(i,1),istrv(i,2),rzev(i),fkstrv(i)
  26  write(3,22) istrv(i,1),istrv(i,2),rzev(i),fkstrv(i)
  24  read(2,*) nbendu
      if(nbendu.gt.maxbe) call emerg (302)
      if(nbendu.eq.0) go to 27
      write(3,28) nbendu
  28  format(i5,' bending functions solute')
      do 29 i=1,nbendu
      read(2,*) (ibendu(i,j),j=1,3),tzz,fkbndu(i)
      write(3,30) (ibendu(i,j),j=1,3),tzz,fkbndu(i)
  29  tzeu(i)=cos(tzz*0.0174533)
  30  format(3i5,2f10.4)
  27  read(2,*) nbendv
      if(nbendv.gt.maxbe) call emerg (302)
      if(nbendv.eq.0) go to 31
      write(3,32) nbendv
  32  format(i5,' bending functions solvent')
      do 33 i=1,nbendv
      read(2,*) (ibendv(i,j),j=1,3),tzz,fkbndv(i)
      write(3,30) (ibendv(i,j),j=1,3),tzz,fkbndv(i)
  33  tzev(i)=cos(tzz*0.0174533) 
  31  read(2,*) ntorsu
      if(ntorsu.gt.maxto) call emerg (303)
      if(ntorsu.eq.0) go to 34
      write(3,35)
  35  format(' solute torsion functions')
      do 36 i=1,ntorsu
      read(2,*) (itorsu(i,j),j=1,4),fktrsu(i),fasu(i),ftru(i)
      write(3,37) (itorsu(i,j),j=1,4),fktrsu(i),fasu(i),ftru(i)
c 37  format(4i4,f8.2,2f6.1,2x,7e11.3)  !Old
  37  format(4i4,f8.2,2f6.1)            !New, 24/02/2020
  36  continue
  34  read(2,*) ntorsv
      if(ntorsv.gt.maxto) call emerg (303) 
      if(ntorsv.eq.0) go to 38
      write(3,39)
  39  format(' solvent torsion functions')
      do 40 i=1,ntorsv
      read(2,*) (itorsv(i,j),j=1,4),fktrsv(i),fasv(i),ftrv(i)
      write(3,37) (itorsv(i,j),j=1,4),fktrsv(i),fasv(i),ftrv(i)
  40  continue
  38  continue
c     read intramolecular nonbonded pairlists
      read(2,*) nlistu
      if(nlistu.eq.0) go to 41 
      read(2,*) ((nblstu(i,j),j=1,2),i=1,nlistu)
      write(3,42) nlistu
  42  format(' solute intramolecular nonbonded pairs',i6)
      write(3,43) ((nblstu(k,m),m=1,2),k=1,nlistu)
  43  format(10(2i3,1x))
  41  read(2,*) nlistv
      if(nlistv.eq.0) go to 44 
      read(2,*) ((nblstv(i,j),j=1,2),i=1,nlistv)
      write(3,45) nlistv
  45  format(' solvent intramolecular nonbonded pairs',i6)
      write(3,43) ((nblstv(k,m),m=1,2),k=1,nlistv)
c     load nonbonded parameters ipots=0 CLP, ipots=1 6-12-q
  44  continue
c     fill auxiliary vectors for subroutine calls  
      do 106 i=1,nasolu
 106  ispu(i)=isp(i)
      if(nasolv.eq.0) go to 207
      do 206 i=1,nasolv
      it=i+nasolu
 206  ispv(i)=isp(it)
c     read clp control coefficients, dummy if ipots=1
 207  read(2,*) fq,fp,fd,fr
      if(ipots.eq.0) go to 101
c     LJC potentials, read parameters 
      write(3,103)
 103  format('  Using 6-12-q potentials ') 
      call potljc (nasolu,nasolv,ispu,ispv,ipri) 
c     subr. potljc also reads additional 6-12 parameters (if any)
c     from topology file 
      return
c     CLP potentials   
 101  write(3,104) fq,fp,fd,fr
 104  format(' using CLP potentials,parameters ',3f8.2,f10.2)
c     damp charges with clp coefficient 
c     fill auxiliary vectors for potclp call 
      do 105 i=1,nasolu
      qq(i)=qq(i)*fq
 105  chu(i)=qq(i)
      if(nasolv.eq.0) go to 210
      do 211 i=1,nasolv
      it=i+nasolu
      qq(it)=qq(it)*fq
 211  chv(i)=qq(it)
 210  continue
      call potclp (nasolu,nasolv,ispu,ispv,chu,chv)
      return
      end
c     ---------------------------------------------------------------
      subroutine rebox (irbox,nvar,nvaru,nvarv,nparu,nparv,
     1 nrepa,nrepb,nrepc,icent)
c     read box file unit 4
c     solute part
      implicit real*8 (a-h,o-z)
      integer*1 isy,isysav
      character*2 head1,head2
      dimension xdum(6),idum(6),savef(100,3),savet(3)
      common /symb/ head1(10),head2(10)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
c     box dimensions and pressure control parameters
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      read(4,*) nmsolu,nstep,icent
c     x,y,z of c.o.m., teta,fi,chi,chirality,six step codes 
      nvar=0
      do 51 i=1,nmsolu
      read(4,*) (xdum(j),j=1,6),ichir(i),(idum(k),k=1,6)
      do 52 m=1,6
      pvar(i,m)=xdum(m)
      if(idum(m).eq.0) go to 52
      nvar=nvar+1
      kv(nvar,1)=i
      kv(nvar,2)=m
      kv(nvar,3)=idum(m)
  52  continue
c     load box file for r,beta,tau for slave atoms
      if(ncardu.eq.0) go to 51
      do 54 j=1,ncardu
      read(4,*) (xdum(ik),ik=1,3),(idum(k),k=1,3)
      m6=7+(j-1)*3
      pvar(i,m6)=xdum(1)
      pvar(i,m6+1)=xdum(2)
      pvar(i,m6+2)=xdum(3)
      do 56 k=1,3
      if(idum(k).eq.0) go to 56
      nvar=nvar+1
      kv(nvar,1)=i
      kv(nvar,2)=m6+k-1
      kv(nvar,3)=idum(k)
  56  continue
  54  continue
  51  continue
c     total number of solute variables
      nvaru=nvar
      nparu=(6+3*ncardu)*nmsolu
c     solvent part
      nparv=0
      nvarv=0
      read(4,*) nmsolv
      if(nmsolv.eq.0) go to 950
      do 951 i=1,nmsolv
      ip=i+nmsolu
      read(4,*) (xdum(j),j=1,6),ichir(ip),(idum(kk),kk=1,6)
      do 952 m=1,6
      pvar(ip,m)=xdum(m)
      if(idum(m).eq.0) go to 952
      nvar=nvar+1
      kv(nvar,1)=ip
      kv(nvar,2)=m
      kv(nvar,3)=idum(m)
 952  continue
c     load box file for r,beta,tau for slave atoms
      if(ncardv.eq.0) go to 951
      do 954 j=1,ncardv
      read(4,*) (xdum(ik),ik=1,3),(idum(k),k=1,3)
      m6=7+(j-1)*3
      pvar(ip,m6)=xdum(1)
      pvar(ip,m6+1)=xdum(2)
      pvar(ip,m6+2)=xdum(3)
      do 954 k=1,3
      if(idum(k).eq.0) go to 955
      nvar=nvar+1
      kv(nvar,1)=ip
      kv(nvar,2)=m6+k-1
      kv(nvar,3)=idum(k)
 955  continue
 954  continue
 951  continue
      nvarv=nvar-nvaru
      nparv=(6+3*ncardv)*nmsolv
 950  if(irbox.ne.0) read(4,*) boxx,boxy,boxz,albox,bebox,gabox,
     1 nrepa,nrepb,nrepc
      if(albox.lt.1.0) albox=90.0
      if(bebox.lt.1.0) bebox=90.0
      if(gabox.lt.1.0) gabox=90.0
      return
      end
c     ---------------------------------------------------------------
      subroutine cocres (nstep)
c     compute com of computational box
c     restore coordinates of box to initial com when required
      implicit real*8 (a-h,o-z)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      sx=0.0
      sy=0.0
      sz=0.0
      ft=nmsolu*nasolu+nmsolv*nasolv
      do 1 i=1,nmsolu
      do 1 j=1,nasolu
      sx=sx+xf(i,j)
      sy=sy+yf(i,j)
  1   sz=sz+zf(i,j)
      if(nmsolv.eq.0) go to 2
      do 3 i=1,nmsolv
      ip=i+nmsolu
      do 3 j=1,nasolv
      sx=sx+xf(ip,j)
      sy=sy+yf(ip,j)
  3   sz=sz+zf(ip,j)
  2   sx=sx/ft
      sy=sy/ft
      sz=sz/ft
c      write(6,8) nstep,sx,sy,sz
c 8    format(i10,3f9.4,' new c.o.c.')
      tre=180.0
      trem=-tre
c     refer box to current c.o.c
      do 4 i=1,nmsolu
      pvar(i,1)=pvar(i,1)-sx
      pvar(i,2)=pvar(i,2)-sy
      pvar(i,3)=pvar(i,3)-sz
c     renormalize rotation angles
      do 9 kk=4,6
      if(pvar(i,kk).gt.tre) pvar(i,kk)=pvar(i,kk)-360.0
  9   if(pvar(i,kk).lt.trem) pvar(i,kk)=pvar(i,kk)+360.0
c     renormalize torsion angles
      if(ncardu.eq.0) go to 40
      do 41 j=1,ncardu 
      kp=9+(j-1)*3
      if(pvar(i,kp).gt.tre) pvar(i,kp)=pvar(i,kp)-360.0
      if(pvar(i,kp).lt.trem) pvar(i,kp)=pvar(i,kp)+360.0
  41  continue
  40  do 44 j=1,nasolu
      xf(i,j)=xf(i,j)-sx
      yf(i,j)=yf(i,j)-sy
  44  zf(i,j)=zf(i,j)-sz
  4   continue
      if(nmsolv.eq.0) go to 5
      do 6 i=1,nmsolv
      ip=i+nmsolu
      pvar(ip,1)=pvar(ip,1)-sx
      pvar(ip,2)=pvar(ip,2)-sy
      pvar(ip,3)=pvar(ip,3)-sz
c     renormalize rotation angles
      do 7 kk=4,6
      if(pvar(ip,kk).gt.tre) pvar(ip,kk)=pvar(ip,kk)-360.0
 7    if(pvar(ip,kk).lt.trem) pvar(ip,kk)=pvar(ip,kk)+360.0
c     renormalize torsion angles
      if(ncardv.eq.0) go to 45
      do 46 j=1,ncardv 
      kp=9+(j-1)*3
      if(pvar(ip,kp).gt.tre) pvar(ip,kp)=pvar(ip,kp)-360.0
      if(pvar(ip,kp).lt.trem) pvar(ip,kp)=pvar(ip,kp)+360.0
  46  continue
  45  do 47 j=1,nasolv
      xf(ip,j)=xf(ip,j)-sx
      yf(ip,j)=yf(ip,j)-sy
  47  zf(ip,j)=zf(ip,j)-sz
 6    continue
 5    continue
      return
      end
c     ---------------------------------------------------------------
      subroutine boxch (numol)
c     check if atoms of molecule numol are within box limits
      implicit real*8 (a-h,o-z)
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      nat=nasolu
      if(numol.gt.nmsolu) nat=nasolv
      pv1=pvar(numol,1)
      pv2=pvar(numol,2)
      pv3=pvar(numol,3)
      pz=0.01745329
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vabc=sqrt(vabc)
      cccs=(cali-cbei*cgai)/sgai
      if(ibx.eq.0) go to 21
c     ttx is boxx times fractional x of c.o.c.
c     compares with 0.5*boxx
      ttx=pv1-pv2*cgai/sgai+pv3*(cgai*cccs-cbei*sgai)/vabc
      boxxh=boxx*0.5
      bxmen=-boxxh
      shif=0.0
c     sho is orthogonalized (1 0 0) translation vector
      sho1=boxx
      if(ttx.gt.boxxh) shif=-1.0
      if(ttx.lt.bxmen) shif=1.0
      pvar(numol,1)=pvar(numol,1)+shif*sho1
      do 1 i=1,nat
  1   xf(numol,i)=xf(numol,i)+shif*sho1
 21   if(iby.eq.0) go to 31
c     tty is boxy times fractional y of c.o.c.
c     compares with 0.5*boxy
      tty=pv2/sgai-pv3*cccs/vabc
      boxyh=boxy*0.5
      bymen=-boxyh
      shif=0.0
c     sho is orthogonalized (0 1 0) translation vector
      sho1=boxy*cgai
      sho2=boxy*sgai
      if(tty.gt.boxyh) shif=-1.0
      if(tty.lt.bymen) shif=1.0
      pvar(numol,1)=pvar(numol,1)+shif*sho1
      pvar(numol,2)=pvar(numol,2)+shif*sho2
      do 2 i=1,nat
      xf(numol,i)=xf(numol,i)+shif*sho1
  2   yf(numol,i)=yf(numol,i)+shif*sho2
 31   if(ibz.eq.0) go to 54
c     ttz is boxz times fractional z of c.o.c.
c     compares with 0.5*boxz
      ttz=pv3*sgai/vabc
      boxzh=boxz*0.5
      bzmen=-boxzh
      shif=0.0
c     sho is orthogonalized (0 0 1) translation vector
      sho1=boxz*cbei
      sho2=boxz*cccs
      sho3=boxz*vabc/sgai
      if(ttz.gt.boxzh) shif=-1.0
      if(ttz.lt.bzmen) shif=1.0
      pvar(numol,1)=pvar(numol,1)+shif*sho1
      pvar(numol,2)=pvar(numol,2)+shif*sho2
      pvar(numol,3)=pvar(numol,3)+shif*sho3
      do 3 i=1,nat
      xf(numol,i)=xf(numol,i)+shif*sho1
      yf(numol,i)=yf(numol,i)+shif*sho2
  3   zf(numol,i)=zf(numol,i)+shif*sho3
  54  continue
c      write(3,102) nmove
c 102  format(' Box periodicity check at move',i7)
      return
      end
c     ---------------------------------------------------------------
      subroutine boxexp (xold,yold,zold,alold,beold,gaold,vold,vnew)
c     calculate new centers and coordinates after box change
      implicit real*8 (a-h,o-z)
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      call cocres(0)
      pz=0.01745329
c     old metrics
      cali=cos(alold*pz)
      cbei=cos(beold*pz)
      cgai=cos(gaold*pz)
      sgai=sin(gaold*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vabc=sqrt(vabc)
      vold=vabc*xold*yold*zold
      cccs=(cali-cbei*cgai)/sgai
c     new metrics
      cal2=cos(albox*pz)
      cbe2=cos(bebox*pz)
      cga2=cos(gabox*pz)
      sga2=sin(gabox*pz)
      vab2=1.0-cal2**2-cbe2**2-cga2**2+2.0*cal2*cbe2*cga2
      vab2=sqrt(vab2)
      vnew=vab2*boxx*boxy*boxz
      ccc2=(cal2-cbe2*cga2)/sga2
      do 1 i=1,nmsolu
c     compute old fractional c.o.c. components ttx,tty,ttz
      pv1=pvar(i,1)
      pv2=pvar(i,2)
      pv3=pvar(i,3)
      ttx=pv1-pv2*cgai/sgai+pv3*(cgai*cccs-cbei*sgai)/vabc
      ttx=ttx/xold
      tty=(pv2/sgai-pv3*cccs/vabc)/yold
      ttz=pv3*sgai/(vabc*zold)
c     compute new orthogonalised c.o.c. and find displacement
      pvar(i,1)=ttx*boxx+tty*boxy*cga2+ttz*boxz*cbe2
      pvar(i,2)=tty*boxy*sga2+ttz*boxz*ccc2
      pvar(i,3)=ttz*boxz*vab2/sga2
      dx=pvar(i,1)-pv1
      dy=pvar(i,2)-pv2
      dz=pvar(i,3)-pv3
c     apply displacement to all atoms
      do 2 j=1,nasolu
      xf(i,j)=xf(i,j)+dx
      yf(i,j)=yf(i,j)+dy
  2   zf(i,j)=zf(i,j)+dz
  1   continue
      if(nmsolv.eq.0) go to 101
c     same procedure for solvent
      do 3 k=1,nmsolv
      i=k+nmsolu
      pv1=pvar(i,1)
      pv2=pvar(i,2)
      pv3=pvar(i,3)
      ttx=pv1-pv2*cgai/sgai+pv3*(cgai*cccs-cbei*sgai)/vabc
      ttx=ttx/xold
      tty=(pv2/sgai-pv3*cccs/vabc)/yold
      ttz=pv3*sgai/(vabc*zold)
      pvar(i,1)=ttx*boxx+tty*boxy*cga2+ttz*boxz*cbe2
      pvar(i,2)=tty*boxy*sga2+ttz*boxz*ccc2
      pvar(i,3)=ttz*boxz*vab2/sga2
      dx=pvar(i,1)-pv1
      dy=pvar(i,2)-pv2
      dz=pvar(i,3)-pv3
      do 4 j=1,nasolv
      xf(i,j)=xf(i,j)+dx
      yf(i,j)=yf(i,j)+dy
  4   zf(i,j)=zf(i,j)+dz
  3   continue
 101  nmtot=nmsolv+nmsolu
      do 5 i=1,nmtot
      call boxch(i)
  5   continue
      call cocres(0)
      return
      end
c     ---------------------------------------------------------------
c     slave atoms subroutine
      subroutine slaves (numol,ishx,ishc,ishmol,ncards,natoms)
      implicit real*8 (a-h,o-z)
c     common blocks
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      pz=0.01745329
      natot=nasolu+nasolv
      do 634 i=1,natot
      do 634 j=1,3
 634  xlab(i,j)=xcore(i,j)
      if(ncards.eq.0) return
      do 1 kk=1,ncards
      ns=3*(kk-1)+6
      kkish=kk+ishc
      iw1=islav(kkish,1)
      iw2=islav(kkish,2)
      iw3=islav(kkish,3)
      nat1=iw1+ishx
      nat2=iw2+ishx
      nat3=iw3+ishx
      k4=islav(kkish,4)+ishx
      k5=islav(kkish,5)+ishx
      k6=islav(kkish,6)+ishx
      rwant=pvar(numol,ns+1)
      beta=pvar(numol,ns+2)
      tau=pvar(numol,ns+3)
c     Z-type
   4  if(iw2.lt.0) go to 201
c     bisector
      if(iw2.eq.0.and.iw3.eq.0) go to 301
c     methylene
      if(iw3.eq.0) go to 401
c     methine
      if(iw2.eq.0) go to 501
c     methyl
      go to 601
c     Z-type routine
 201  continue
      call zmat(nat1,k4,k5,k6,rwant,beta,tau)
      go to 1
c     bisector routine
 301  continue
      dx=xlab(k4,1)-0.5*(xlab(k5,1)+xlab(k6,1))
      dy=xlab(k4,2)-0.5*(xlab(k5,2)+xlab(k6,2))
      dz=xlab(k4,3)-0.5*(xlab(k5,3)+xlab(k6,3))
      rw=rwant/sqrt(dx**2+dy**2+dz**2)
      xlab(nat1,1)=xlab(k4,1)+dx*rw
      xlab(nat1,2)=xlab(k4,2)+dy*rw
      xlab(nat1,3)=xlab(k4,3)+dz*rw
      go to 1
c     methylene routine
 401  continue
      call ang(k4,k5,k6,alfa)
      arg=0.5*beta*pz
      hs=rwant*sin(arg)
      bs=rwant*cos(arg)
      dx=xlab(k4,1)-0.5*(xlab(k5,1)+xlab(k6,1))
      dy=xlab(k4,2)-0.5*(xlab(k5,2)+xlab(k6,2))
      dz=xlab(k4,3)-0.5*(xlab(k5,3)+xlab(k6,3))
      rw=bs/sqrt(dx**2+dy**2+dz**2)
      sx=xlab(k4,1)+dx*rw
      sy=xlab(k4,2)+dy*rw
      sz=xlab(k4,3)+dz*rw
      bmcx=xlab(k4,1)-xlab(k5,1)
      bmcy=xlab(k4,2)-xlab(k5,2)
      bmcz=xlab(k4,3)-xlab(k5,3)
      bmax=xlab(k4,1)-xlab(k6,1)
      bmay=xlab(k4,2)-xlab(k6,2)
      bmaz=xlab(k4,3)-xlab(k6,3)
      pvz=bmcx*bmay-bmcy*bmax
      pvy=bmcz*bmax-bmcx*bmaz
      pvx=bmcy*bmaz-bmcz*bmay
      pvmod=sqrt(pvx**2+pvy**2+pvz**2)
      rw=hs/pvmod
      xlab(nat1,1)=sx+rw*pvx
      xlab(nat1,2)=sy+rw*pvy
      xlab(nat1,3)=sz+rw*pvz
      xlab(nat2,1)=sx-rw*pvx
      xlab(nat2,2)=sy-rw*pvy
      xlab(nat2,3)=sz-rw*pvz
      go to 1
c     methine routine
 501  continue
      xc=(xlab(k4,1)+xlab(k5,1)+xlab(k6,1))/3.0
      yc=(xlab(k4,2)+xlab(k5,2)+xlab(k6,2))/3.0
      zc=(xlab(k4,3)+xlab(k5,3)+xlab(k6,3))/3.0
      dx=xlab(nat3,1)-xc
      dy=xlab(nat3,2)-yc
      dz=xlab(nat3,3)-zc
      d=sqrt(dx**2+dy**2+dz**2)
      xlab(nat1,1)=xlab(nat3,1)+rwant*dx/d
      xlab(nat1,2)=xlab(nat3,2)+rwant*dy/d
      xlab(nat1,3)=xlab(nat3,3)+rwant*dz/d
      go to 1
c     methyl routine
 601  continue
      call zmat(nat1,k4,k5,k6,rwant,beta,tau)
      tau=tau+120.0
      call zmat(nat2,k4,k5,k6,rwant,beta,tau)
      tau=tau+120.0
      call zmat(nat3,k4,k5,k6,rwant,beta,tau)
  1   continue
      return
      end
c     ---------------------------------------------------------------
      subroutine zmat(nat,k4,k5,k6,rwant,beta,tau)
      implicit real*8 (a-h,o-z)
      common /work/ vec(100,3),rmat(100,3,3)
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
c     calculate atom position on Z-matrix type procedure
      pz=0.0174533
      do 1 i=1,4
      do 1 j=1,3
  1   vec(i,j)=0.0
      r45=0.0
      do 2 i=1,3
      vec(1,i)=xlab(k4,i)-xlab(k5,i)
      r45=r45+vec(1,i)**2
  2   vec(3,i)=xlab(k6,i)-xlab(k5,i)
      r45=sqrt(r45)
      proj=sqrt(vec(1,1)**2+vec(1,2)**2)
      cchi=vec(1,1)/proj
      schi=-vec(1,2)/proj
      call fill(cchi,schi,1,3)
      do 3 i=1,3
      call prtr(1,i,i)
  3   continue
      czet=vec(1,1)/r45
      szet=-vec(1,3)/r45
      call fill(czet,szet,2,2)
      do 4 i=1,3
      call prtr(2,i,i)
  4   continue
      proj=sqrt(vec(3,2)**2+vec(3,3)**2)
      cchi=vec(3,2)/proj
      schi=-vec(3,3)/proj
      call fill (cchi,schi,3,1)
      call prtr(3,3,3)
      arg=pz*(180.0-beta)
      vec(4,1)=vec(1,1)+rwant*cos(arg)
      vec(4,2)=rwant*sin(arg)
      zero=vec(3,2)*vec(4,2)
      if(zero.lt.0.0) vec(4,2)=-vec(4,2) 
      ctau=cos(tau*pz)
      stau=sin(tau*pz)
      call fill(ctau,stau,4,1)
      call prtr(4,4,4)
      call prma(2,1,5)
      call prma(3,5,5)
      do 5 i=1,3
      do 5 j=1,3
  5   rmat(6,j,i)=rmat(5,i,j)
      call prma(5,6,7)
      call prtr(6,4,4)
      do 6 i=1,3
  6   xlab(nat,i)=vec(4,i)+xlab(k5,i)
      return
      end
c     ---------------------------------------------------------------
      subroutine einter (nm)
c     compute intermolecular energy for molecule nm
      implicit real*8 (a-h,o-z)
      character*2 symbol
      dimension xdum(6),idum(6),dcre(3),boxve(27,3)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /e/ elpu(2000,2000),equ(2000,2000),elpv(2000,2000),
     1 eqv(2000,2000),elpuv(2000,2000),equv(2000,2000),ulp(2000),
     2 uq(2000),vlp(2000),vq(2000),uvlp(2000),uvq(2000),
     4 uulpez,vvlpez,uvlpez,uuqez,vvqez,uvqez,elpz,eqz,
     5 ezero,cutuu,cutuv,cutvv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
c     potential tables
      common/potato/ ptu(100,100,3),ptv(100,100,3),ptuv(100,100,3),
     1 deru(100,100,3),derv(100,100,3),deruv(100,100,3),fq,fp,fd,fr
c     atomic species
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
c     prepare table for box boundary construction
      ib=0
      dcre(1)=0.0
      dcre(2)=-1.0
      dcre(3)=1.0
      itx=1
      if(ibx.ne.0) itx=3
      ity=1
      if(iby.ne.0) ity=3
      itz=1
      if(ibz.ne.0) itz=3
c     translation vectors are orthogonalized
      pz=0.01745329
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vabc=sqrt(vabc)
      cccs=(cali-cbei*cgai)/sgai
      do 631 i=1,itx
      do 631 j=1,ity
      do 631 k=1,itz
      ib=ib+1
      boxve(ib,1)=dcre(i)*boxx+dcre(j)*boxy*cgai+
     1 dcre(k)*boxz*cbei
      boxve(ib,2)=dcre(j)*boxy*sgai+dcre(k)*boxz*cccs
 631  boxve(ib,3)=dcre(k)*boxz*vabc/sgai
      pz1=pvar(nm,1)
      pz2=pvar(nm,2)
      pz3=pvar(nm,3)
      if(nm.gt.nmsolu) go to 100
c --- nm is a solute molecule  -----------------------------
c     open loop for solute-solute interaction   
      do 1 jmo=1,nmsolu
      p1=pvar(jmo,1)
      p2=pvar(jmo,2)
      p3=pvar(jmo,3)
      ulp(jmo)=0.0
      uq(jmo)=0.0
      eij=0.0
      ecij=0.0
      do 2 kbox=1,ib
      if(nm.eq.jmo.and.kbox.eq.1) go to 2
      bbxx=boxve(kbox,1)
      bbxy=boxve(kbox,2)
      bbxz=boxve(kbox,3)
      rc=(pz1-p1-bbxx)**2+(pz2-p2-bbxy)**2+(pz3-p3-bbxz)**2
      rc=sqrt(rc)
      if(rc.gt.cutuu) go to 2
c     open atom-atom loops
      do 3 k=1,nasolu
      qk=qq(k)
      xxx=xf(nm,k)
      yyy=yf(nm,k)
      zzz=zf(nm,k)
      do 6 m=1,nasolu
      xuj=xf(jmo,m)+bbxx
      yuj=yf(jmo,m)+bbxy
      zuj=zf(jmo,m)+bbxz
      r=sqrt((xxx-xuj)**2+(yyy-yuj)**2+(zzz-zuj)**2)
      ecij=ecij+qk*qq(m)/r
      if(ipots.eq.1) go to 61
c     clp potentials 
      eij=eij-ptu(k,m,1)*r**(-4)-ptu(k,m,2)*r**(-6)
     1 +ptu(k,m,3)*r**(-12)
      go to 6
c     6-12 potentials
  61  eij=eij-ptu(k,m,1)*r**(-6)+ptu(k,m,2)*r**(-12)
c     close atom-atom loops
  6   continue
  3   continue
c     close loop on box surrounding molecules
  2   continue
      ecij=ecij*1389.355
      ulp(jmo)=eij
      uq(jmo)=ecij
c     close loop on all other molecules
  1   continue
      if(nmsolv.eq.0) return
c     open loop for solute-solvent interaction   
      do 11 jmo=1,nmsolv
      jmp=jmo+nmsolu
      p1=pvar(jmp,1)
      p2=pvar(jmp,2)
      p3=pvar(jmp,3)
      eij=0.0
      ecij=0.0
      do 12 kbox=1,ib
      bbxx=boxve(kbox,1)
      bbxy=boxve(kbox,2)
      bbxz=boxve(kbox,3)
      rc=(pz1-p1-bbxx)**2+(pz2-p2-bbxy)**2+(pz3-p3-bbxz)**2
      rc=sqrt(rc)
      if(rc.gt.cutuv) go to 12
c     open atom-atom loops
      do 13 k=1,nasolu
      qk=qq(k)
      xxx=xf(nm,k)
      yyy=yf(nm,k)
      zzz=zf(nm,k)
      do 16 m=1,nasolv
      xuj=xf(jmp,m)+bbxx
      yuj=yf(jmp,m)+bbxy
      zuj=zf(jmp,m)+bbxz
      r=sqrt((xxx-xuj)**2+(yyy-yuj)**2+(zzz-zuj)**2)
      ecij=ecij+qk*qq(m+nasolu)/r
      if(ipots.eq.1) go to 71
c     clp potentials 
      eij=eij-ptuv(k,m,1)*r**(-4)-ptuv(k,m,2)*r**(-6)
     1 +ptuv(k,m,3)*r**(-12)
      go to 16
c     6-12 potentials
  71  eij=eij-ptuv(k,m,1)*r**(-6)+ptuv(k,m,2)*r**(-12)
c     close atom-atom loops
  16  continue
  13  continue
c     close loop on box surrounding molecules
  12  continue
      ecij=ecij*1389.355
      uvlp(jmo)=eij
      uvq(jmo)=ecij
c     close loop on all other molecules
  11  continue
      return
c --- nm is a solvent molecule  -----------------------------
c     open loop for solvent-solvent interaction   
 100  continue
      do 21 jmo=1,nmsolv
      jmp=jmo+nmsolu
      vlp(jmo)=0.0
      vq(jmo)=0.0
      p1=pvar(jmp,1)
      p2=pvar(jmp,2)
      p3=pvar(jmp,3)
      eij=0.0
      ecij=0.0
      do 22 kbox=1,ib
      if(nm.eq.jmp.and.kbox.eq.1) go to 22
      bbxx=boxve(kbox,1)
      bbxy=boxve(kbox,2)
      bbxz=boxve(kbox,3)
      rc=(pz1-p1-bbxx)**2+(pz2-p2-bbxy)**2+(pz3-p3-bbxz)**2
      rc=sqrt(rc)
      if(rc.gt.cutvv) go to 22
      do 23 k=1,nasolv
      qk=qq(k+nasolu)
      xxx=xf(nm,k)
      yyy=yf(nm,k)
      zzz=zf(nm,k)
      do 26 m=1,nasolv
      xuj=xf(jmp,m)+bbxx
      yuj=yf(jmp,m)+bbxy
      zuj=zf(jmp,m)+bbxz
      r=sqrt((xxx-xuj)**2+(yyy-yuj)**2+(zzz-zuj)**2)
      ecij=ecij+qk*qq(m+nasolu)/r
      if(ipots.eq.1) go to 81
      eij=eij-ptv(k,m,1)*r**(-4)-ptv(k,m,2)*r**(-6)
     1 +ptv(k,m,3)*r**(-12)
      go to 26
  81  eij=eij-ptv(k,m,1)*r**(-6)+ptv(k,m,2)*r**(-12)
  26  continue
  23  continue
c     close loop on box surrounding molecules
  22  continue
      ecij=ecij*1389.355
      vlp(jmo)=eij
      vq(jmo)=ecij
  21  continue
c     open loop for solvent-solute interaction
      do 31 jmo=1,nmsolu
      p1=pvar(jmo,1)
      p2=pvar(jmo,2)
      p3=pvar(jmo,3)
      eij=0.0
      ecij=0.0
      do 32 kbox=1,ib
      bbxx=boxve(kbox,1)
      bbxy=boxve(kbox,2)
      bbxz=boxve(kbox,3)
      rc=(pz1-p1-bbxx)**2+(pz2-p2-bbxy)**2+(pz3-p3-bbxz)**2
      rc=sqrt(rc)
      if(rc.gt.cutuv) go to 32
      do 33 k=1,nasolv
      qk=qq(k+nasolu)
      xxx=xf(nm,k)
      yyy=yf(nm,k)
      zzz=zf(nm,k)
      do 36 m=1,nasolu
      xuj=xf(jmo,m)+bbxx
      yuj=yf(jmo,m)+bbxy
      zuj=zf(jmo,m)+bbxz
      r=sqrt((xxx-xuj)**2+(yyy-yuj)**2+(zzz-zuj)**2)
      ecij=ecij+qk*qq(m)/r
      if(ipots.eq.1) go to 91
      eij=eij-ptuv(m,k,1)*r**(-4)-ptuv(m,k,2)*r**(-6)
     1 +ptuv(m,k,3)*r**(-12)
      go to 36
  91  eij=eij-ptuv(m,k,1)*r**(-6)+ptuv(m,k,2)*r**(-12)
  36  continue
  33  continue
  32  continue
      ecij=ecij*1389.355
      uvlp(jmo)=eij
      uvq(jmo)=ecij
  31  continue
      return
      end
c     ---------------------------------------------------------------
      subroutine eintra (nmol,estr,ebend,etors,enonb)
c     compute intramolecular energy of molecule nmol
      implicit real*8 (a-h,o-z)
      character*2 symbol
      dimension rij(3),rkj(3),rkl(3),rim(3),rln(3)
      dimension xdum(6),idum(6)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /intraf/ rzeu(50),fkstru(50),tzeu(50),fkbndu(50),
     1rzev(50),fkstrv(50),tzev(50),fkbndv(50),
     2fktrsu(30),fasu(30),ftru(20),fktrsv(30),fasv(30),ftrv(30),
     3ebondu(2000),ebondv(2000)
      common /intrai/nstru,istru(50,2),nbendu,ibendu(50,3),
     1 nstrv,istrv(50,2),nbendv,ibendv(50,3),
     2 ntorsu,itorsu(30,4),nblstu(1000,2),
     3 nlistu,ntorsv,itorsv(30,4),nblstv(1000,2),nlistv
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common/potato/ ptu(100,100,3),ptv(100,100,3),ptuv(100,100,3),
     1 deru(100,100,3),derv(100,100,3),deruv(100,100,3),fq,fp,fd,fr
      enonb=0.0
      estr=0.0
      ebend=0.0
      etors=0.0
      if(nmol.gt.nmsolu) go to 101
c     solute part
      if(nstru.eq.0) go to 11
      do 12 i=1,nstru
      i1=istru(i,1)
      i2=istru(i,2)
      r=(xf(nmol,i1)-xf(nmol,i2))**2
      r=r+(yf(nmol,i1)-yf(nmol,i2))**2
      r=r+(zf(nmol,i1)-zf(nmol,i2))**2
      r=sqrt(r)
      estr=estr+0.5*fkstru(i)*(r-rzeu(i))**2
  12  continue
  11  if(nbendu.eq.0) go to 13
      do 14 i=1,nbendu
      i1=ibendu(i,1)
      i2=ibendu(i,2)
      i3=ibendu(i,3)
      r1=xf(nmol,i1)-xf(nmol,i2)
      r2=yf(nmol,i1)-yf(nmol,i2)
      r3=zf(nmol,i1)-zf(nmol,i2)
      s1=xf(nmol,i3)-xf(nmol,i2)
      s2=yf(nmol,i3)-yf(nmol,i2)
      s3=zf(nmol,i3)-zf(nmol,i2)
      r=sqrt(r1**2+r2**2+r3**2)
      s=sqrt(s1**2+s2**2+s3**2)
      ang=(r1*s1+r2*s2+r3*s3)/(r*s)
c      ang=acos(ang)/0.017453
  14  ebend=ebend+0.5*fkbndu(i)*(ang-tzeu(i))**2
  13  if(ntorsu.eq.0) go to 15
      do 16 i=1,ntorsu
      i1=itorsu(i,1)
      i2=itorsu(i,2)
      i3=itorsu(i,3)
      i4=itorsu(i,4)
c     see GROMOS manual page II-26
      rij(1)=xf(nmol,i1)-xf(nmol,i2)
      rij(2)=yf(nmol,i1)-yf(nmol,i2)
      rij(3)=zf(nmol,i1)-zf(nmol,i2)
      rkj(1)=xf(nmol,i3)-xf(nmol,i2)
      rkj(2)=yf(nmol,i3)-yf(nmol,i2)
      rkj(3)=zf(nmol,i3)-zf(nmol,i2)
      rkl(1)=xf(nmol,i3)-xf(nmol,i4)
      rkl(2)=yf(nmol,i3)-yf(nmol,i4)
      rkl(3)=zf(nmol,i3)-zf(nmol,i4)
      rkj2=rkj(1)**2+rkj(2)**2+rkj(3)**2
      pr1=rij(1)*rkj(1)+rij(2)*rkj(2)+rij(3)*rkj(3)
      pr1=pr1/rkj2
      rim(1)=rij(1)-pr1*rkj(1)
      rim(2)=rij(2)-pr1*rkj(2)
      rim(3)=rij(3)-pr1*rkj(3)
      pr2=rkl(1)*rkj(1)+rkl(2)*rkj(2)+rkl(3)*rkj(3)
      pr2=pr2/rkj2
      rln(1)=-rkl(1)+pr2*rkj(1)
      rln(2)=-rkl(2)+pr2*rkj(2)
      rln(3)=-rkl(3)+pr2*rkj(3)
      rimm=sqrt(rim(1)**2+rim(2)**2+rim(3)**2)
      rlnm=sqrt(rln(1)**2+rln(2)**2+rln(3)**2)
      cosf=rim(1)*rln(1)+rim(2)*rln(2)+rim(3)*rln(3)
      cosf=cosf/(rimm*rlnm)
      torer=abs(cosf)-1.0
      if(torer.le.0.0) go to 21
      if(torer.gt.0.0001) call emerg (1200)
      cosen=1.000            
      if(cosf.lt.0.0) cosen=-1.0000
      cosf=cosen
c     cosf = -1 tau=180, cosf=1 tau = 0 
c     tau always positive and 0<tau<180
 21   tau=acos(cosf)/0.0174533
  22  argo=ftru(i)*tau*0.017453
      etors=etors+fktrsu(i)*(1.+fasu(i)*cos(argo))
  16  continue
  15  if(nlistu.eq.0) return
      do 18 i=1,nlistu
      k=nblstu(i,1)
      m=nblstu(i,2)
      qr=qq(k)*qq(m)*1389.355
      r=(xf(nmol,k)-xf(nmol,m))**2  
      r=r+(yf(nmol,k)-yf(nmol,m))**2+(zf(nmol,k)-zf(nmol,m))**2
      r=sqrt(r)
      if(ipots.eq.1) go to 23
c     clp potentials 
      enonb=enonb-ptu(k,m,1)*r**(-4)-ptu(k,m,2)*r**(-6)
     1 +ptu(k,m,3)*r**(-12)+qr/r
      go to 18
c     6-12 potentials
  23  enonb=enonb-ptu(k,m,1)*r**(-6)+ptu(k,m,2)*r**(-12)+qr/r
  18  continue
      return
c     solvent part ---------------------------------------------------
  101 continue
      if(nstrv.eq.0) go to 111
      do 112 i=1,nstrv
      i1=istrv(i,1)
      i2=istrv(i,2)
      r=(xf(nmol,i1)-xf(nmol,i2))**2
      r=r+(yf(nmol,i1)-yf(nmol,i2))**2
      r=r+(zf(nmol,i1)-zf(nmol,i2))**2
      r=sqrt(r)
 112  estr=estr+0.5*fkstrv(i)*(r-rzev(i))**2
 111  if(nbendv.eq.0) go to 113
      do 114 i=1,nbendv
      i1=ibendv(i,1)
      i2=ibendv(i,2)
      i3=ibendv(i,3)
      r1=xf(nmol,i1)-xf(nmol,i2)
      r2=yf(nmol,i1)-yf(nmol,i2)
      r3=zf(nmol,i1)-zf(nmol,i2)
      s1=xf(nmol,i3)-xf(nmol,i2)
      s2=yf(nmol,i3)-yf(nmol,i2)
      s3=zf(nmol,i3)-zf(nmol,i2)
      r=sqrt(r1**2+r2**2+r3**2)
      s=sqrt(s1**2+s2**2+s3**2)
      ang=(r1*s1+r2*s2+r3*s3)/(r*s)
c      ang=acos(ang)/0.017453
 114  ebend=ebend+0.5*fkbndv(i)*(ang-tzev(i))**2
 113  if(ntorsv.eq.0) go to 132
      do 134 i=1,ntorsv
      i1=itorsv(i,1)
      i2=itorsv(i,2)
      i3=itorsv(i,3)
      i4=itorsv(i,4)
c     see GROMOS manual page II-26
      rij(1)=xf(nmol,i1)-xf(nmol,i2)
      rij(2)=yf(nmol,i1)-yf(nmol,i2)
      rij(3)=zf(nmol,i1)-zf(nmol,i2)
      rkj(1)=xf(nmol,i3)-xf(nmol,i2)
      rkj(2)=yf(nmol,i3)-yf(nmol,i2)
      rkj(3)=zf(nmol,i3)-zf(nmol,i2)
      rkl(1)=xf(nmol,i3)-xf(nmol,i4)
      rkl(2)=yf(nmol,i3)-yf(nmol,i4)
      rkl(3)=zf(nmol,i3)-zf(nmol,i4)
      rkj2=rkj(1)**2+rkj(2)**2+rkj(3)**2
      pr1=rij(1)*rkj(1)+rij(2)*rkj(2)+rij(3)*rkj(3)
      pr1=pr1/rkj2
      rim(1)=rij(1)-pr1*rkj(1)
      rim(2)=rij(2)-pr1*rkj(2)
      rim(3)=rij(3)-pr1*rkj(3)
      pr2=rkl(1)*rkj(1)+rkl(2)*rkj(2)+rkl(3)*rkj(3)
      pr2=pr2/rkj2
      rln(1)=-rkl(1)+pr2*rkj(1)
      rln(2)=-rkl(2)+pr2*rkj(2)
      rln(3)=-rkl(3)+pr2*rkj(3)
      rimm=sqrt(rim(1)**2+rim(2)**2+rim(3)**2)
      rlnm=sqrt(rln(1)**2+rln(2)**2+rln(3)**2)
      cosf=rim(1)*rln(1)+rim(2)*rln(2)+rim(3)*rln(3)
      cosf=cosf/(rimm*rlnm)
      torer=abs(cosf)-1.0
      if(torer.le.0.0) go to 133
      if(torer.gt.0.0001) call emerg (1200)
      cosen=1.000            
      if(cosf.lt.0.0) cosen=-1.0000
      cosf=cosen
 133  tau=acos(cosf)/0.0174533
 135  argo=ftrv(i)*tau*0.017453
      etors=etors+fktrsv(i)*(1.+fasv(i)*cos(argo))
 134  continue
 132  if(nlistv.eq.0) return
      do 118 i=1,nlistv
      k=nblstv(i,1)
      m=nblstv(i,2)
      qr=qq(k+nasolu)*qq(m+nasolu)*1389.355
      r=(xf(nmol,k)-xf(nmol,m))**2  
      r=r+(yf(nmol,k)-yf(nmol,m))**2+(zf(nmol,k)-zf(nmol,m))**2
      r=sqrt(r)
      if(ipots.eq.1) go to 119
c     clp potentials 
      enonb=enonb-ptv(k,m,1)*r**(-4)-ptv(k,m,2)*r**(-6)
     1 +ptv(k,m,3)*r**(-12)+qr/r
      go to 118
c     6-12 potentials
  119 enonb=enonb-ptv(k,m,1)*r**(-6)+ptv(k,m,2)*r**(-12)+qr/r
  118 continue
      return
      end
c     ---------------------------------------------------------------
      subroutine dipbox (imk,edipce)
c     calculates box dipole and kroon-van eijck correction to Ecoul
c     march2013
c     imk<0 recalculate all dipoles
c     imk>0 recalculate dipole of molecule imk
      implicit real*8 (a-h,o-z)
      dimension dimom(3),dimop(3),diport(4000,3)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
c     box dipole related quantities
      common /boxd/ sqpu,sqmu,sqpv,sqmv,boxdix,boxdiy,boxdiz
c     compute molecular dipoles
c     stop if monoatomic fragment
      if(nasolu.eq.1.or.nasolv.eq.1) call emerg (123)
c     stop if unbalanced charges
      suto=abs(sqpu+sqmu)
      if(suto.gt.0.001) call emerg(124)
      suto=abs(sqpv+sqmv)
      if(suto.gt.0.001) call emerg(124)
      if(imk.gt.0) go to 101
c     recalculate all dipoles
      boxdix=0.0
      boxdiy=0.0
      boxdiz=0.0
      nmtot=nmsolu+nmsolv
      do 11 i=1,nmtot
      do 1 j=1,3
      dimom(j)=0.0
   1  dimop(j)=0.0
c     dipole of i-th molecule in box
      itop=nasolu
      if(i.gt.nmsolu) itop=nasolv
      do 12 j=1,itop
      jp=j
      if(i.gt.nmsolu) jp=j+nasolu
      quq=qq(jp)
      if(quq.gt.0.0) go to 13
      dimom(1)=dimom(1)+xf(i,j)*quq
      dimom(2)=dimom(2)+yf(i,j)*quq
      dimom(3)=dimom(3)+zf(i,j)*quq
      go to 12
  13  dimop(1)=dimop(1)+xf(i,j)*quq
      dimop(2)=dimop(2)+yf(i,j)*quq
      dimop(3)=dimop(3)+zf(i,j)*quq
  12  continue
      sp=sqpu
      sm=sqmu
      if(i.gt.nmsolu) sp=sqpv
      if(i.gt.nmsolu) sm=sqmv
      do 14 j=1,3
      dimom(j)=dimom(j)/sm
      dimop(j)=dimop(j)/sp
      dix=(dimop(j)-dimom(j))
  14  diport(i,j)=dix*sqpu
c     boxdix,y,z components of total box dipole
      boxdix=boxdix+diport(i,1)
      boxdiy=boxdiy+diport(i,2)
      boxdiz=boxdiz+diport(i,3)
c     end loop on solute molecules in box
  11  continue
      go to 300
c     recalculate only dipole of molecule imk
 101  continue
c     subtract old dipole component for mol. imk
      boxdix=boxdix-diport(imk,1)
      boxdiy=boxdiy-diport(imk,2)
      boxdiz=boxdiz-diport(imk,3)
      do 421 j=1,3
      dimom(j)=0.0
 421  dimop(j)=0.0
      itop=nasolu
      if(imk.gt.nmsolu) itop=nasolv
      do 412 j=1,itop
      jp=j
      if(imk.gt.nmsolu) jp=j+nasolu
      quq=qq(jp)
      if(quq.gt.0.0) go to 413
      dimom(1)=dimom(1)+xf(imk,j)*quq
      dimom(2)=dimom(2)+yf(imk,j)*quq
      dimom(3)=dimom(3)+zf(imk,j)*quq
      go to 412
 413  dimop(1)=dimop(1)+xf(imk,j)*quq
      dimop(2)=dimop(2)+yf(imk,j)*quq
      dimop(3)=dimop(3)+zf(imk,j)*quq
 412  continue
      sp=sqpu
      sm=sqmu
      if(imk.gt.nmsolu) sp=sqpv
      if(imk.gt.nmsolu) sm=sqmv
      do 414 j=1,3
      dimom(j)=dimom(j)/sm
      dimop(j)=dimop(j)/sp
      dix=(dimop(j)-dimom(j))
 414  diport(imk,j)=dix*sp
c     add new dipole component for molecule imk
      boxdix=boxdix+diport(imk,1)
      boxdiy=boxdiy+diport(imk,2)
      boxdiz=boxdiz+diport(imk,3)
c     now compute total box dipole energy
 300  continue
      boxdip=boxdix**2+boxdiy**2+boxdiz**2
      fact=-1389.355*3.1416*2.0/3.0
      pz=0.0174533
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vbox=sqrt(vabc)*boxx*boxy*boxz
      edipce=fact*boxdip/vbox
      return
      end
c     ---------------------------------------------------------------
      subroutine writra  (nuste,it1,it2,nvar,mxmol,
     1 nrepa,nrepb,nrepc,icent )
c     output graphic file unit it1
c     output box file unit it2
      implicit real*8 (a-h,o-z)
      character*2 head1,head2,symbol,buffer(100),sf
      dimension ipvar(4000,150)
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      common /symb/ head1(10),head2(10)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
      common /var/ pvar(4000,150),kv(20000,3),npar
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
c     output frame in dat format
      fmov=float(nuste)
      if(it1.eq.0) go to 11
      write(it1,61) 'TITL',nuste
      write(it1,62) nmsolu,nmsolv,nasolu,nasolv,0
      write(it1,68) boxx,boxy,boxz,albox,bebox,gabox,nrepa,nrepb,nrepc 
   61 format(a4,' trajectory at MC step n.',15x,i10)
   62 format('#',5i5)
   68 format('#',3f10.4,3f10.3,3i5)
      write(it1,66) 1.,1.,1.,90.,90.,90.
   66 format('CELL',6f6.1)
c     write solute coordinates
      do 65 j=1,nmsolu
      do 65 i=1,nasolu
      in=isp(i)
      write(it1,64) 'atom',symbol(in),xf(j,i),yf(j,i),zf(j,i)
   64 format(a4,2x,a2,3f10.5)
   65 continue
      if(nmsolv.eq.0) go to 67
      do 75 j=1,nmsolv
      j1=j+nmsolu
      do 75 i=1,nasolv
      in=isp(i+nasolu)
      if(in.gt.3) go to 76
   76 write(it1,64) 'atom',symbol(in),xf(j1,i),yf(j1,i),zf(j1,i)
   75 continue
   67 write(it1,64) 'END '
c     output frame in box format
   11 if(it2.eq.0) return
c     restore variable parameter codes
      do 101 k=1,mxmol
      do 101 m=1,150
 101  ipvar(k,m)=0
      do 102 k=1,nvar
      k1=kv(k,1)
      k2=kv(k,2)
      k3=kv(k,3)
 102  ipvar(k1,k2)=k3
      write(it2,103) nmsolu,nuste,icent
 103  format(i5,i9,i5)
      do 104 i=1,nmsolu
      write(it2,105) (pvar(i,j),j=1,6),ichir(i),(ipvar(i,k),k=1,6),i
 105  format(3f9.4,3f9.2,i3,1x,6i2,i5)
      if(ncardu.eq.0) go to 104
      kk=7
      do 110 mm=1,ncardu
      km=kk+2
      write(it2,111) (pvar(i,jh),jh=kk,km),(ipvar(i,jk),jk=kk,km)
 111  format(f10.4,2f10.2,3i3)
      kk=kk+3
 110  continue
 104  continue
      write(it2,103) nmsolv
      if(nmsolv.eq.0) go to 211
      do 204 i=1,nmsolv
      ip=i+nmsolu
      write(it2,105) (pvar(ip,j),j=1,6),ichir(ip),(ipvar(ip,k),k=1,6),i
      if(ncardv.eq.0) go to 204
      kk=7
      do 210 mm=1,ncardv
      km=kk+2
      write(it2,111) (pvar(ip,jh),jh=kk,km),(ipvar(ip,jk),jk=kk,km)
      kk=kk+3
 210  continue
 204  continue
 211  write(it2,212) boxx,boxy,boxz,albox,bebox,gabox,nrepa,nrepb,nrepc
 212  format(6f10.4,3i5)
      return
      end
c     ---------------------------------------------------------------
      subroutine writen (nmove,wemolu,wemolv)
      implicit real*8 (a-h,o-z)
      dimension ei(2000),eqi(2000),nsym(6),nhist(21),sout(2000)
      common /e/ elpu(2000,2000),equ(2000,2000),elpv(2000,2000),
     1 eqv(2000,2000),elpuv(2000,2000),equv(2000,2000),ulp(2000),
     2 uq(2000),vlp(2000),vq(2000),uvlp(2000),uvq(2000),
     4 uulpez,vvlpez,uvlpez,uuqez,vvqez,uvqez,elpz,eqz,
     5 ezero,cutuu,cutuv,cutvv
      common /intraf/ rzeu(50),fkstru(50),tzeu(50),fkbndu(50),
     1rzev(50),fkstrv(50),tzev(50),fkbndv(50),
     2fktrsu(30),fasu(30),ftru(20),fktrsv(30),fasv(30),ftrv(30),
     3ebondu(2000),ebondv(2000)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      ebu=0.0
      ebv=0.0
      do 4 i=1,nmsolu
 4    ebu=ebu+ebondu(i)
      if(nmsolv.eq.0) go to 21
      do 11 i=1,nmsolv
 11   ebv=ebv+ebondv(i) 
 21   continue
      pz=0.01745329
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      boxvo=sqrt(vabc)*boxx*boxy*boxz
      write(10,5) nmsolu,nasolu,nmsolv,nasolv,wemolu,wemolv
 5    format(4i5,2f10.3) 
      write(10,1) nmove
 1    format(i8)
      wetot=float(nmsolu)*wemolu+float(nmsolv)*wemolv
      dcell=1.6606*wetot/boxvo
      write(10,2) boxx,boxy,boxz,albox,bebox,gabox,dcell
 2    format(3f10.4,3f10.3,f8.3)
c     Elp solute-solute,solvent-solvent,solute-solvent, id Eq
      write(10,3) uulpez,uuqez,vvlpez,vvqez,uvlpez,uvqez
c     write warning,no intram separate energies (only in MD) 
      write(10,3) (-1.0,k=1,8) 
c     total Elp, total Eq, Eintra solute, Eintra solvent,Etot    
      write(10,3) elpz,eqz,ebu,ebv,ezero
 3    format(8f10.1)
      return
      end
c     ---------------------------------------------------------------
      subroutine euler(numol,natom,ishi) 
      implicit real*8 (a-h,o-z)
      dimension com(3),eu(3,3)
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      common /var/ pvar(4000,150),kv(20000,3),npar
      pz=0.0174533
      teta=pvar(numol,4)
      fi=pvar(numol,5)
      chi=pvar(numol,6)
      c1=cos(teta*pz)
      s1=sin(teta*pz)
      c2=cos(fi*pz)
      s2=sin(fi*pz)
      c3=cos(chi*pz)
      s3=sin(chi*pz)
      eu(1,1)=C2*C3
      eu(1,2)=-C1*S3+S1*S2*C3                                                 
      eu(1,3)=S1*S3+C1*S2*C3                                                  
      eu(2,1)=C2*S3                                                           
      eu(2,2)=C1*C3+S1*S2*S3                                                  
      eu(2,3)=-S1*C3+C1*S2*S3                                                 
      eu(3,1)=-S2                                                             
      eu(3,2)=S1*C2                                                           
      eu(3,3)=C1*C2
c     apply overall rotation to i-th molecule
      do 1 i=1,natom
      is=i+ishi
      do 2 j=1,3
      com(j)=0.0
      do 2 k=1,3
  2   com(j)=com(j)+eu(j,k)*xlab(is,k)
      xlab(is,1)=com(1)
      xlab(is,2)=com(2)
      xlab(is,3)=com(3)
  1   continue
      return
      end
      subroutine matfix (cchi,schi,czet,szet,ind)
      implicit real*8 (a-h,o-z)
      dimension rm1(3,3),rm2(3,3),eu(3,3),pro(200,3)
      common /fix/ bin(200,3),bix(200,3),bit(200,3)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
c     now orient x-axis along supposed screw axis
c     first rotation on z
      DO 1 J=1,3
      DO 1 L=1,3                                                                
 1    RM1(J,L)=0.0                                                             
      RM1(3,3)=1.0                                                             
      RM1(1,1)=cchi                                                              
      RM1(2,2)=cchi                                                               
      RM1(1,2)=-schi                                                              
      RM1(2,1)=schi                                                               
c     second rotation around y
      DO 4 J=1,3
      DO 4 L=1,3                                                                
 4    RM2(J,L)=0.0                                                             
      RM2(2,2)=1.0                                                             
      RM2(1,1)=czet                                                               
      RM2(3,3)=czet                                                               
      RM2(1,3)=-szet                                                              
      RM2(3,1)=szet                                                               
      do 3 ii=1,3
      do 2 jj=1,3
      eu(ii,jj)=0.0
      do 2 kk=1,3
   2  eu(ii,jj)=eu(ii,jj)+rm2(ii,kk)*rm1(kk,jj)
   3  continue
c     now project coordinates along direction of axis
      do 6 i=1,nasolu
      inf=i+nasolu
      do 7 k=1,3
      pro(i,k)=0.0
      pro(inf,k)=0.0
      do 7 j=1,3
      pro(inf,k)=pro(inf,k)+bin(inf,j)*eu(k,j)
  7   pro(i,k)=pro(i,k)+bin(i,j)*eu(k,j)
c      write(2,8) i,(pro(i,kk),kk=1,3),(pro(inf,ll),ll=1,3)
c  8   format(i5,3f8.4,2x,3f8.4)
  6   continue
      na=2*nasolu
      do 9 i=1,na
      do 9 k=1,3
      if(ind.eq.1) bix(i,k)=pro(i,k)
      if(ind.eq.2) bit(i,k)=pro(i,k)
  9   continue
      return
      end
c     ---------------------------------------------------------------
      subroutine fill (c,s,nn,mm)
      implicit real*8 (a-h,o-z)
      common /work/ vec(100,3),rmat(100,3,3)
c     counterclockwise rot matrix
      do 1 i=1,3
      do 2 j=1,3
    2 rmat(nn,i,j)=0.0
    1 rmat(nn,i,i)=1.0
      go to (4,5,6),mm
    4 rmat(nn,2,2)=c
      rmat(nn,3,3)=c
      rmat(nn,2,3)=-s
      rmat(nn,3,2)=s
      go to 7
    5 rmat(nn,1,1)=c
      rmat(nn,3,3)=c
      rmat(nn,1,3)=-s
      rmat(nn,3,1)=s
      go to 7
    6 rmat(nn,1,1)=c
      rmat(nn,2,2)=c
      rmat(nn,1,2)=-s
      rmat(nn,2,1)=s
    7 return
      end
      subroutine prtr(ii,jj,kk)
      implicit real*8 (a-h,o-z)
      dimension b(3)
      common /work/ vec(100,3),rmat(100,3,3)
      do 1 i=1,3
      b(i)=0.0
      do 1 j=1,3
    1 b(i)=b(i)+rmat(ii,i,j)*vec(jj,j)
      do 2 i=1,3
    2 vec(kk,i)=b(i)
      return
      end
      subroutine prma(ii,jj,kk)
      implicit real*8 (a-h,o-z)
      dimension b(3,3)
      common /work/ vec(100,3),rmat(100,3,3)
      do 1 i=1,3
      do 1 j=1,3
      b(i,j)=0.0
      do 2 k=1,3
    2 b(i,j)=b(i,j)+rmat(ii,i,k)*rmat(jj,k,j)
    1 continue
      do 3 i=1,3
      do 3 j=1,3
    3 rmat(kk,i,j)=b(i,j)
      return
      end
      subroutine ang(ia,ja,ka,alfa)
      implicit real*8 (a-h,o-z)
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
      d1=xlab(ja,1)-xlab(ia,1)
      d2=xlab(ja,2)-xlab(ia,2)
      d3=xlab(ja,3)-xlab(ia,3)
      e1=xlab(ka,1)-xlab(ia,1)
      e2=xlab(ka,2)-xlab(ia,2)
      e3=xlab(ka,3)-xlab(ia,3)
      d=sqrt(d1**2+d2**2+d3**2)
      e=sqrt(e1**2+e2**2+e3**2)
      co=(d1*e1+d2*e2+d3*e3)/(d*e)
      alfa=acos(co)/0.0174533
      return
      end
      subroutine emerg (kk)
      if(kk.eq.1200) write(3,1200)
 1200 format(' cosine of torsion angle out of range')
      if(kk.eq.987) write(3,987)
 987  format(' something wrong with input intram nonbonded functions')
      if(kk.eq.123) write(3,123)
 123  format(' cannot use cell dip. energy with monoatomic species')
      if(kk.eq.124) write(3,124)
 124  format(' cannot use cell dip. energy with unbalanced charges')
      if(kk.eq.91) write(3,91)
 91   format(' attempted use of velocity calcn., program stop')
      if(kk.eq.87) write(3,87)
 87   format(' unallowed pressure control procedure')
      if(kk.eq.88) write(3,88)
 88   format(' pressure or box control but no periodic box')
      if(kk.eq.89) write(3,89)
 89   format(' pressure or box control but wrong ianis')
      if(kk.eq.52) write(3,52)
  52  format(' too many solute molecules')
      if(kk.eq.51) write(3,51)
  51  format(' too many solvent molecules') 
      if(kk.eq.53) write(3,53)
  53  format(' too many slave cards solute or solvent ') 
      if(kk.eq.54) write(3,54)
  54  format(' zero temperature not acceptable ') 
      if(kk.eq.11) write(3,11)
  11  format(' cutoff shorter than box dimension')
      if(kk.eq.12) write (3,12)
  12  format(' zero variables, program cannot continue')
      if(kk.eq.301) write(3,301)
      if(kk.eq.302) write(3,302)
      if(kk.eq.303) write(3,303)
 301  format(' too many stretching functions')
 302  format(' too many bending functions')
 303  format(' too many torsion functions') 
      write(6,6)
   6  format(' $$$$$program stops for inconsistency, see printfile')
      stop
      end
      subroutine potclp (nasolu,nasolv,ispu,ispv,qqu,qqv)
      implicit real*8(a-h,o-z)
      dimension ispu(100),ispv(100),qqu(100),qqv(100)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
      common/potato/ ptu(100,100,3),ptv(100,100,3),ptuv(100,100,3),
     1 deru(100,100,3),derv(100,100,3),deruv(100,100,3),fq,fp,fd,fr
c     solute-solute potentials 
      do 1 i=1,nasolu
      is1=ispu(i)
      q1=qqu(i)
      qn1=qnum(is1)
      zv1=zval(is1)
      dif1=diffu(is1)
      pol1=polat(is1)*((zv1-q1)/zv1)
      pot1=potio(is1)
      do 2 j=1,nasolu
      is2=ispu(j)
      q2=qqu(j)
      zv2=zval(is2)
      qn2=qnum(is2)
      dif2=diffu(is2)
      dd=sqrt(dif1*dif2)
      pol2=polat(is2)*((zv2-q2)/zv2)
      pot2=potio(is2)
      alfeff=sqrt(pol1*pol2)
      absq=abs(q1*q2)
      qnef=qn1*qn2
      potef=sqrt(pot1*pot2)
      ptu(i,j,1)=alfeff*absq*fp
      ptu(i,j,2)=alfeff*qnef*potef*fd
      dij=(zv1-q1)
      dkm=(zv2-q2)
      pt3=dij*dkm*dd
      hbo=acdo(is1)*acdo(is2)
      if(hbo.lt.0.0) pt3=(1.0+hbo)*pt3
      ptu(i,j,3)=pt3*fr
  2   continue
      if(nasolv.eq.0) go to 1
c     solute-solvent potentials 
      do 3 j=1,nasolv
      is2=ispv(j)
      q2=qqv(j)
      zv2=zval(is2)
      qn2=qnum(is2)
      dif2=diffu(is2)
      dd=sqrt(dif1*dif2)
      pol2=polat(is2)*((zv2-q2)/zv2)
      pot2=potio(is2)
      alfeff=sqrt(pol1*pol2)
      absq=abs(q1*q2)
      qnef=qn1*qn2
      potef=sqrt(pot1*pot2)
      ptuv(i,j,1)=alfeff*absq*fp
      ptuv(i,j,2)=alfeff*qnef*potef*fd
      dij=(zv1-q1)
      dkm=(zv2-q2)
      pt3=dij*dkm*dd
      hbo=acdo(is1)*acdo(is2)
      if(hbo.lt.0.0) pt3=(1.0+hbo)*pt3
  3   ptuv(i,j,3)=pt3*fr
  1   continue
c     solvent-solvent potentials 
      if(nasolv.eq.0) return
      do 4 i=1,nasolv
      is1=ispv(i)
      q1=qqv(i)
      qn1=qnum(is1)
      zv1=zval(is1)
      dif1=diffu(is1)
      pol1=polat(is1)*((zv1-q1)/zv1)
      pot1=potio(is1)
      do 4 j=1,nasolv
      is2=ispv(j)
      q2=qqv(j)
      zv2=zval(is2)
      qn2=qnum(is2)
      dif2=diffu(is2)
      dd=sqrt(dif1*dif2)
      pol2=polat(is2)*((zv2-q2)/zv2)
      pot2=potio(is2)
      alfeff=sqrt(pol1*pol2)
      absq=abs(q1*q2)
      qnef=qn1*qn2
      potef=sqrt(pot1*pot2)
      ptv(i,j,1)=alfeff*absq*fp
      ptv(i,j,2)=alfeff*qnef*potef*fd
      dij=(zv1-q1)
      dkm=(zv2-q2)
      pt3=dij*dkm*dd
      hbo=acdo(is1)*acdo(is2)
      if(hbo.lt.0.0) pt3=(1.0+hbo)*pt3
  4   ptv(i,j,3)=pt3*fr
      return
      end 
c     --------------------------------------------------------------
c     lennard-jones 6-12 potential coefficients for LJC scheme
      subroutine potljc (nasolu,nasolv,ispu,ispv,ipri)
      implicit real*8 (a-h,o-z)
      dimension ispu(100),ispv(100) 
      common/potato/ ptu(100,100,3),ptv(100,100,3),ptuv(100,100,3),
     1deru(100,100,3),derv(100,100,3),deruv(100,100,3),fq,fp,fd,fr
c     LJ coefficients are in block data alldat 
      common /lj/ c6(70),c12(70),clj(70,70,2) 
      maxspe=70
      do 21 i=1,maxspe
      clj(i,i,1)=c6(i)
  21  clj(i,i,2)=c12(i)
      do 23 i=1,maxspe
      do 23 j=1,maxspe
      clj(i,j,1)=dsqrt(clj(i,i,1)*clj(j,j,1))
      clj(i,j,2)=dsqrt(clj(i,i,2)*clj(j,j,2))
  23  continue
c     read extra 6-12 potentials from topology file 
      read(2,*) nextra
      if(nextra.eq.0) go to 26
      write(3,22) nextra
  22  format( ' reading ',i4,' extra Lennard-Jones parameters')
      do 20 i=1,nextra
      read(2,*) k,m,cof1,cof2
      clj(k,m,1)=cof1
      clj(k,m,2)=cof2
      clj(m,k,1)=cof1
      clj(m,k,2)=cof2
      write(3,24) k,m,clj(k,m,1),clj(k,m,2)
  24  format(2i5,f11.1,f10.1)
  20  continue 
  26  if(ipri.eq.0) go to 25
      write(3,2)
   2  format(' hydrogen non H-bonding ')
      write(3,4) clj(1,1,1),clj(1,1,2)
   4  format(3x,f10.1,2x,e13.5)
      write(3,5)
   5  format(' hydrogen H-bonding, zero 6-12 potential ')
      write(3,7)
   7  format(' carbon, any ') 
      write(3,4) clj(10,10,1),clj(10,10,2)
      write(3,9)
   9  format( ' nitrogen, any ') 
      write(3,4) clj(16,16,1),clj(16,16,2)
      write(3,11)
  11  format( ' oxygen, any ')
      write(3,4) clj(23,23,1),clj(23,23,2)
      write(3,18)
  18  format(' water oxygen ?? untested ') 
      write(3,4) clj(24,24,1),clj(24,24,2)
      write(3,13)
  13  format( ' sulfur, any ')
      write(3,4) clj(34,34,1),clj(34,34,2)
      write(3,15)
  15  format( ' fluorine, chlorine, bromine, iodine ')
      write(3,4) clj(41,41,1),clj(41,41,2)
      write(3,4) clj(42,42,1),clj(42,42,2)
      write(3,4) clj(43,43,1),clj(43,43,2)
      write(3,4) clj(44,44,1),clj(44,44,2)
c     ----------------------------------------------------------
c     set atom-atom LJ coefficients and derivatives 
c     ----------------------------------------------------------
c     solute-solute
  25  do 31 i=1,nasolu
      ispi=ispu(i)
      do 31 j=1,nasolu
      ispj=ispu(j)
      ptu(i,j,1)=clj(ispi,ispj,1)
      deru(i,j,1)=6.0*ptu(i,j,1)
      ptu(i,j,2)=clj(ispi,ispj,2)
  31  deru(i,j,2)=12.0*ptu(i,j,2)
      if(nasolv.eq.0) return
c     solute-solvent
      do 32 i=1,nasolu
      ispi=ispu(i)
      do 32 j=1,nasolv
      ispj=ispv(j)
      ptuv(i,j,1)=clj(ispi,ispj,1)
      deruv(i,j,1)=6.0*ptuv(i,j,1)
      ptuv(i,j,2)=clj(ispi,ispj,2)
  32  deruv(i,j,2)=12.0*ptuv(i,j,2)
c     solvent-solvent
      do 33 i=1,nasolv
      ispi=ispv(i)
      do 33 j=1,nasolv
      ispj=ispv(j)
      ptv(i,j,1)=clj(ispi,ispj,1)
      derv(i,j,1)=6.0*ptv(i,j,1)
      ptv(i,j,2)=clj(ispi,ispj,2)  
  33  derv(i,j,2)=12.0*ptv(i,j,2)  
c     compute derivatives of intermolecular potentials
      return
      end 
      block data
      implicit real*8 (a-h,o-z) 
      character*2 symbol
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
      common /lj/ c6(70),c12(70),clj(70,70,2) 
c     -----------------------------------------------------------
      data symbol/
     1' H',' H',' H','  ',' H',' H',' H',' H',' H',' C',
     2' C',' C',' C',' C','  ',' N',' N',' N',' N',' N',
     3' N','  ',' O',' O','  ','  ',' O',' O',' O',' O',
     4' O',' O','  ',' S',' S',' S',' S',' P','  ','  ',
     5' F','Cl','Br',' I','  ','  ','  ','  ','  ','  ',
     6'Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn','  ',
c      positive ions                  negative ions
     7'Li','Na',' K','Rb','Cs','Ca',' F','Cl','Br',' I'/
c     atomic weights
      data wei/
     1 1.0079,1.0079,1.0079,0.0,1.0079,1.0079,3*1.0079,12.011,
     2 12.011,12.011,12.011,12.011,0.0,14.007,14.007,14.007,2*14.007,
     3 14.007,0.0,16.0,16.0,0.0,0.0,16.0,16.0,16.0,16.0,
     4 16.0,16.0,0.000,32.07,32.07,32.07,32.07,30.97,0.0,0.0,
     5 19.0,35.453,79.904,126.9,6*0.0,
     6 47.88,50.94,52.00,54.94,55.85,58.93,58.69,63.55,63.58,0.0,
     7 6.94,22.99,39.10,85.47,132.91,40.08,19.0,35.453,79.94,126.9/        
c     average bonding radii version of 8.2011
      data ravrg/
     1 0.30,0.30,0.30,0.00,0.30,0.30,0.30,0.30,0.30,0.70,
     2 0.60,0.70,0.77,0.70,0.00,0.75,0.75,0.65,0.55,0.72,
     3 0.70,0.00,0.68,0.68,0.00,0.00,0.55,0.68,0.68,0.50,
     4 0.40,0.40,0.00,1.05,1.05,1.05,1.05,1.05,0.0,0.0,
     5 0.65,1.00,1.20,1.35,6*0.0,
     6 1.32,1.22,1.17,1.17,1.16,1.16,1.15,1.35,1.31,0.0,
     7 0.70,1.00,1.10,1.20,1.30,1.10,1.35,1.40,1.50,1.60/
c     non-bonded radii
      data ravdw/
     1 1.10,1.10,1.10,0.00,1.10,1.10,1.10,1.10,1.10,1.77,
     2 1.77,1.77,1.77,1.77,0.00,1.64,1.64,1.64,1.64,1.64,
     3 1.64,0.00,1.58,1.58,0.00,0.00,1.58,1.58,1.58,1.58,
     4 1.58,1.58,0.00,1.81,1.81,1.81,1.81,1.90,0.00,0.00,
     5 1.46,1.76,1.87,2.03,6*0.0,
     6 2.15,2.05,2.05,2.05,2.05,2.00,2.00,2.00,2.10,0.00,
     7 0.70,1.00,1.50,1.60,1.70,1.10,1.35,1.80,1.95,2.16/
c     total electron numbers 
      data zeta/
     1 1.,1.,1.,0.,1.,1.,1.,1.,1.,6.,
     2 6.,6.,6.,6.,0.,7.,7.,7.,7.,7.,
     3 7.,0.,8.,8.,0.,0.,8.,8.,8.,8.,
     4 8.,8.,0.,16.,16.,16.,16.,15.,0.0,0.0,
     5 9.0,17.0,35.0,53.0,6*0.0,
     6 22.0,23.0,24.0,25.0,26.0,27.0,28.0,29.0,30.0,0.0,
     7 3.00,11.0,19.0,37.0,55.0,20.0,10.0,18.0,36.0,54.0/
c     number of valence electrons
      data zval/
     1 1.,1.,1.,0.,1.,1.,1.,1.,1.,4.,
     2 4.,4.,4.,4.,0.,5.,5.,5.,5.,5.,
     3 5.,0.,6.,6.,0.,0.,6.,6.,6.,6.,
     4 6.,6.,0.,6.,6.,6.,6.,5.,0.0,0.0,
     5 7.,7.,17.,17.,6*0.0,
     6 4.,5.,6.,7.,8.,9.,10.,11.,12.,0.0,
     7 2.,8.,8.,18.,18.,8.,8.,8.,18.,18./
c     quantum number of valence electrons
      data qnum/
     1 1.0,1.0,1.0,0.0,1.0,1.0,1.0,1.0,1.0,2.0,
     2 2.0,2.0,2.0,2.0,0.0,2.0,2.0,2.0,2.0,2.0,
     3 2.0,0.0,2.0,2.0,0.0,0.0,2.0,2.0,2.0,2.0,
     4 2.0,2.0,0.0,3.0,3.0,3.0,3.0,3.0,0.0,0.0,
     5 2.0,3.0,4.0,5.0,6*0.0,
     6 3.0,3.0,3.0,3.0,3.0,3.0,3.0,3.0,3.0,0.0,
     7 1.0,2.0,3.0,4.0,5.0,3.0,2.0,3.0,4.0,5.0/
c    AA-clp and PIXEL atomic polarizabilities
c    adapted from Miller JACS 112,8573,1990
      data polat/
     1 0.39,0.39,0.39,0.00,0.39,0.39,0.39,0.39,0.39,1.05,
     2 1.35,1.35,1.05,1.90,0.00,1.00,1.00,1.05,1.00,1.00,
     3 1.00,0.00,0.75,0.75,0.00,0.00,0.75,0.75,0.75,0.75,
     4 0.75,0.75,0.00,3.00,3.00,3.00,3.00,1.54,0.0,0.0,
     5 0.40,2.50,3.27,5.00,6*0.00, 
     6 4.18,3.31,2.86,2.93,2.81,2.62,2.61,2.81,3.63,0.00,
     7 0.10,0.20,0.30,0.40,0.30,0.70,0.40,2.50,3.27,5.00/
c     AA-clp diffuseness factors
      data diffu/
     1 0.60,0.62,0.64,0.00,0.75,0.80,0.80,0.80,0.80,1.00,
     2 1.00,1.00,1.00,1.00,0.00,0.63,0.63,0.58,0.70,0.63,
     3 0.63,0.00,0.45,0.70,0.00,0.00,0.50,0.50,0.45,0.50,
     4 0.75,0.75,0.00,2.00,2.00,2.50,2.00,3.00,0.00,0.00,
     5 0.20,2.40,1.50,5.00,6*0.00,
     6 0.80,0.80,0.80,0.80,0.80,0.80,0.80,0.80,0.80,0.00,
     7 0.20,0.30,1.50,3.00,5.00,1.50,0.50,3.00,4.00,5.00/
c    AA-clp acceptor-donor index
      data acdo/
     1 0.20,0.10,0.05,0.00,0.99,0.99,0.90,0.99,0.99,0.00,
     2 0.00,0.00,0.00,0.00,0.00,0.00,-0.97,-0.99,-0.70,0.00,
     3 -0.85,0.00,-0.90,-0.99,0.00,0.00,-0.99,-0.90,-0.97,-0.95,
     4 -0.90,-0.90,0.00,-0.50,-0.50,0.00,-0.50,0.00,0.00,0.00,
     5 0.00,-0.20,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,
     6 -0.50,-0.50,-0.50,-0.50,-0.50,-0.50,-0.50,-0.50,-0.50,0.0,
     7 0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00/
c     Pauling electronegativities
      data elneg/
     1 2.10,2.10,2.10,0.00,2.10,2.10,2.10,2.10,2.10,2.50,
     2 2.50,2.50,2.50,2.50,0.00,3.00,3.00,3.00,3.00,3.00,
     3 3.00,0.00,3.50,3.50,0.00,0.00,3.50,3.50,3.50,3.50,
     4 3.50,3.50,0.00,2.50,2.50,2.50,2.50,2.10,0.00,0.00,
     5 4.00,3.00,2.80,2.50,6*0.00,
     6 1.32,1.45,1.56,1.60,1.64,1.70,1.75,1.75,1.66,0.00,
     7 0.50,0.50,0.50,0.50,0.50,0.50,4.00,3.00,2.80,2.50/
c     ionization potentials
      data potio/
     1 0.500,0.500,0.500,0.000,0.500,0.500,0.500,0.500,0.500,0.414,
     2 0.414,0.414,0.414,0.414,0.000,0.534,0.534,0.534,0.534,0.534,
     3 0.534,0.000,0.500,0.500,0.000,0.000,0.500,0.500,0.500,0.500,
     4 0.500,0.500,0.000,0.381,0.381,0.381,0.381,0.386,0.000,0.000,
     5 0.640,0.477,0.434,0.384,6*0.0,
     6 0.251,0.248,0.249,0.273,0.289,0.289,0.281,0.284,0.345,0.000,
     7 1.000,0.850,0.700,0.500,0.450,0.700,0.750,0.650,0.500,0.400/
c     PIXEL decay beta-factors for ionization potential
      data difa/
     1 0.40,0.40,0.40,0.00,0.40,0.40,0.40,0.40,0.40,0.90,
     2 0.90,0.90,0.90,0.90,0.00,0.50,0.50,0.50,0.50,0.50,
     3 0.50,0.00,0.35,0.35,0.00,0.00,0.35,0.35,0.35,0.35,
     4 0.35,0.35,0.00,0.40,0.40,0.40,0.40,0.40,0.00,0.00,
     5 0.00,0.15,0.10,0.10,6*0.0, 
     6 0.40,0.40,0.40,0.40,0.40,0.40,0.40,0.40,0.40,0.00,
     7 0.40,0.40,0.40,0.40,0.40,0.40,0.00,0.00,0.00,0.00/
c     Lennard-Jones 6-12 coefficients for hydrogen to iodine
       data c6/
     1 73.8,73.8,73.8,6*0.0,2280.0,
     2 2280.,2280.,2280.,2280.,0.0,2200.,2200.,2200.,2200.,2200.,
     3 2200.,0.0,1650.,2600.,0.0,0.0,1650.,1650.,1650.,1650.,
     4 1650.,1650.,0.0,10000.,10000.,10000.,10000.,0.0,0.0,0.0,
     5 1080.,6400.,11900.,14280.,26*0.0/
       data c12/
     1 14500.,14500.,14500.,6*0.0,4.5d+06,
     2 4*4.5d+06,0.0,5*2.32d+06,
     3 2.32d+06,0.0,1.22d+06,2.6d+06,2*0.0,4*1.22d+06,
     4 1.22d+06,1.22d+06,0.0,4*1.3d+07,3*0.0,
     5 7.6d+05,7.65d+06,1.58d+07,1.90d+07,26*0.0/
      end
      SUBROUTINE JACOB (f,g)
      implicit real*8 (a-h,o-z)
      DIMENSION F(3,3),V(3,3),g(3,3)
      N=3                                                                       
      RHO=0.000001                                                              
      TE=0.0                                                                    
      FUNNO=1.0                                                                 
      DO 20 I=1,3                                                               
      DO 21 J=1,3                                                               
      V(I,J)=0.0                                                                
 21   CONTINUE                                                                  
      V(I,I)=1.0                                                                
 20   CONTINUE                                                                  
      DO 1 I=2,N                                                                
      K=I-1                                                                     
      DO 1 J=1,K                                                                
      TE=TE+2.*F(I,J)*F(I,J)                                                    
 1    CONTINUE                                                                  
      TE=SQRT(TE)                                                               
      MA=0                                                                      
      A=N                                                                       
    2 TE=TE/A                                                                   
      IF(TE.LT.RHO)TE=RHO                                                       
    3 DO 14 II=2,N                                                              
      IJ=II-1                                                                   
      DO 14 JJ=1,IJ                                                             
      IF (ABS(F(II,JJ))-TE)14,4,4                                               
    4 MA=1                                                                      
      V1=F(JJ,JJ)                                                               
      V2=F(II,JJ)                                                               
      V3=F(II,II)                                                               
      U=.5*(F(JJ,JJ)-F(II,II))                                                  
      IF(ABS(U)-RHO)5,6,6                                                       
    5 OMEGA=-1.0                                                                
      GO TO 7                                                                   
   6  FUX=SQRT(F(II,JJ)*F(II,JJ)+U*U)                                           
      OMEGA=-F(II,JJ)/FUX                                                       
      Z=1.                                                                      
      IF (U.LT.0.)Z=-Z                                                          
      OMEGA=OMEGA*Z                                                             
 7    FUX=1.0-OMEGA*OMEGA                                                       
      FEX=2.0*(1.0+SQRT(FUX))                                                   
      SINT=OMEGA/SQRT(FEX)                                                      
      FUNT=FUNNO-SINT*SINT                                                      
      COST=SQRT(FUNT)                                                           
      DO 13 I=1,N                                                               
      IF(I-II)9,8,8                                                             
    8 TEM=F(I,JJ)*COST-F(I,II)*SINT                                             
      F(I,II)=F(I,JJ)*SINT+F(I,II)*COST                                         
      F(I,JJ)=TEM                                                               
      GO TO 12                                                                  
    9 IF(I-JJ)10,11,11                                                          
   10 TEM=F(JJ,I)*COST-F(II,I)*SINT                                             
      F(II,I)=F(JJ,I)*SINT+F(II,I)*COST                                         
      F(JJ,I)=TEM                                                               
      GO TO 12                                                                  
   11 TEM=F(I,JJ)*COST-F(II,I)*SINT                                             
      F(II,I)=F(I,JJ)*SINT+F(II,I)*COST                                         
      F(I,JJ)=TEM                                                               
   12 TEM=V(I,JJ)*COST-V(I,II)*SINT                                             
      V(I,II)=V(I,JJ)*SINT+V(I,II)*COST                                         
      V(I,JJ)=TEM                                                               
 13   CONTINUE                                                                  
      F(JJ,JJ)=V1*COST*COST+V3*SINT*SINT-2.*V2*SINT*COST                        
      F(II,II)=V1*SINT*SINT+V3*COST*COST+2.*V2*SINT*COST                        
      F(II,JJ)=2.*U*SINT*COST+V2*(COST*COST-SINT*SINT)                          
   14 CONTINUE                                                                  
      IF(MA-1)16,15,15                                                          
   15 MA=0                                                                      
      GO TO 3                                                                   
   16 IF(TE-RHO)17,17,2                                                         
C     EIGENVALUE ORDERING                                                       
 17   CONTINUE                                                                  
 310  IF(F(1,1)-F(2,2)) 100,101,101                                             
 101  IF(F(2,2)-F(3,3)) 102,102,103                                             
 103  IND=6                                                                     
      GO TO 200                                                                 
 102  IF(F(1,1)-F(3,3)) 104,104,105                                             
 104  IND=2                                                                     
      GO TO 200                                                                 
 105  IND=5                                                                     
      GO TO 200                                                                 
 100  IF(F(2,2)-F(3,3)) 107,107,108                                             
 107  IND=1                                                                     
      GO TO 200                                                                 
 108  IF(F(1,1)-F(3,3)) 109,109,110                                             
 109  IND=4                                                                     
      GO TO 200                                                                 
 110  IND=3                                                                     
 200  GO TO (116,115,116,115,115,201),IND                                       
 115  F33=F(2,2)                                                                
      F(2,2)=F(3,3)                                                             
      F(3,3)=F33                                                                
      DO 120 I=1,3                                                              
      VC=V(I,3)                                                                 
      V(I,3)=V(I,2)                                                             
 120  V(I,2)=VC                                                                 
 116  IF(IND.EQ.5) GO TO 201                                                    
      GO TO (118,119,119,118) ,IND                                              
 118  F33=F(1,1)                                                                
      F(1,1)=F(3,3)                                                             
      F(3,3)=F33                                                                
      DO 220 I=1,3                                                              
      VC=V(I,3)                                                                 
      V(I,3)=V(I,1)                                                             
 220  V(I,1)=VC                                                                 
      GO TO 201                                                                 
 119  F33=F(2,2)                                                                
      F(2,2)=F(1,1)                                                             
      F(1,1)=F33                                                                
      DO 221 I=1,3                                                              
      VC=V(I,1)                                                                 
      V(I,1)=V(I,2)                                                             
 221  V(I,2)=VC                                                                 
 201  DO 51 I=1,3                                                               
      DO 51 J=1,3                                                               
c      f(i,j)=0.0                                                           
 51   g(I,J)=V(J,I)                                                        
      RETURN                                                                    
      END                                                                      
