c
      program biasmc
c
c     Monte Carlo simulation with CLP or LJC potentials
c     optional collective variable bias, symmetry and condensation
c
c                    ---main module----
c
c     subroutine libraries in mcbili.for and symche.for 
c     atomic data are in alldat.for
c
c     ------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
      character*2 head1,head2,symbol
      dimension xdum(6),idum(6),savef(100,3),savet(3),pstep(10)
      dimension nex(200)
      dimension savep(4000,150),xusav(4000,100),yusav(4000,100),
     1 zusav(4000,100),kvc(20000)
      common /symb/ head1(10),head2(10)
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1             nasolv,nmsolv,ncorev,ncardv,nslavv
      common /e/ elpu(2000,2000),equ(2000,2000),elpv(2000,2000),
     1 eqv(2000,2000),elpuv(2000,2000),equv(2000,2000),ulp(2000),
     2 uq(2000),vlp(2000),vq(2000),uvlp(2000),uvq(2000),
     4 uulpez,vvlpez,uvlpez,uuqez,vvqez,uvqez,elpz,eqz,
     5 ezero,cutuu,cutuv,cutvv 
      common /intraf/ rzeu(50),fkstru(50),tzeu(50),fkbndu(50),
     1rzev(50),fkstrv(50),tzev(50),fkbndv(50),
     2fktrsu(30),fasu(30),ftru(20),fktrsv(30),fasv(30),ftrv(30),
     3ebondu(2000),ebondv(2000)
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100) 
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri 
      common /var/ pvar(4000,150),kv(20000,3),npar
      common /box/boxx,boxy,boxz,albox,bebox,gabox,pres,
     1 ib,ibx,iby,ibz,ial,ibe,iga,kbound
      common /boxd/ sqpu,sqmu,sqpv,sqmv,boxdix,boxdiy,boxdiz
c     -----------------------------------------------------------
c     bias function parameters  
      common /symch/ tolsy,cutsy,wesy(100),wet,nosy(100),nasy
c     -----------------------------------------------------------
      common /sym/ symbol(70)
      common /ats/ wei(70),ravrg(70),ravdw(70),zeta(70),polat(70),
     1qnum(70),zval(70),diffu(70),acdo(70),elneg(70),potio(70),difa(70)
c     files: run control,topology,print,box in,box out,frame-dat 
      open (unit=1, file='mcb.mci')
      open (unit=2, file='mcb.top')
      open (unit=3, file='mcb.mcp')
      open (unit=4, file='mcb.bxi')
      open (unit=8, file='mcb.bxo')
      open (unit=9, file='mcb.mco')
c     max number of atoms, max mols in box, max variables
c     max slave atom lines 
c     max parameters per molecule
c--------------------------------------------------------------------7--
c     section I
 1001 continue
      mxatu=100
      mxatv=100
      mxsolu=2000
      mxsolv=2000
      mxmol=mxsolu+mxsolv
      maxcrd=45
      maxpar=20000
      maxat=mxatu+mxatv
      do 101 i=1,maxat
      do 101 j=1,3
 101  xcore(i,j)=0.0
c     read mci run control file ---------------------------------
      read(1,1) (head1(k),k=1,10)
 1    format(1x,10a2) 
      read(1,3) adum
 3    format(a1)
      read(1,*) ipri,ipots,cutuu,cutuv,cutvv,factin
      read(1,3) adum
      read(1,*) boxx,boxy,boxz,albox,bebox,gabox,
     1 ibx,iby,ibz,ial,ibe,iga,irbox
      read(1,3) adum
      read(1,*) nmomax,ncomc,nboxc,nwrite,ne,npri
      read(1,*) (pstep(k),k=1,5)
      read(1,3) adum
      read(1,*) ftemp,presat,npres,ianis
      read(1,1) adum
      read(1,*) isymch,isy1,isy2,cutsy,tolsy
      nexcs=0
      if(isymch.ne.0)read(1,*) nexcs
      if(nexcs.ne.0) read(1,*) (nex(i),i=1,nexcs)
      write(6,1492)
 1492 format(/1x,' +++++++++  Monte Carlo optional bias  +++++++++ ',
     1 /10x, ' version of may 2021 ')
      write(3,1492) 
      write(3,1493) (head1(k),k=1,10)
 1493 format(/2x,' Run control file header ',2x,10a2)
      if(nwrite.gt.0) open (unit=7, file='mcb.mcc')
      if(ne.gt.0) open (unit=10, file='mcb.ene')
c     kbound.ne.0 if any boundary periodicity present
      kbound=0
      if(ibx.ne.0.or.iby.ne.0.or.ibz.ne.0) kbound=1
c     set box dipole calculation index, iboxdi
      iboxdi=0
      if(ianis.eq.3)ianis=2
      if(ianis.eq.3)iboxdi=1
c     exclude unallowed pressure control procedures
      icom=0
      if(ianis.gt.2) call emerg (87)
      if(nboxc.ne.0.and.npres.ne.0) call emerg (87)
      if(nboxc.ne.0.and.kbound.eq.0) call emerg (88)
      if(npres.ne.0.and.kbound.eq.0) call emerg (88)
      if(npres.ne.0.and.ianis.eq.0) call emerg (89)
c     read topology (force field) file --------------------------------
      call retopo
      write(3,4) cutuu,cutuv,cutvv
 4    format(' cutoffs for center-of-mass distances',3f6.1)
      if(ncardu.gt.maxcrd.or.ncardv.gt.maxcrd) call emerg (53) 
      pmou=0.0
      qup=0.0
      pmov=0.0
      qvp=0.0
      do 103 i=1,nasolu
      ins=isp(i)
      pmou=pmou+ww(i)
      qup=qup+qq(i)
 103  continue
      if(nasolv.eq.0) go to 105 
      do 106 i=1,nasolv
      imo=i+nasolu
      ins=isp(imo)
      pmov=pmov+wei(ins)
      qvp=qvp+qq(imo)
 106  continue
 105  write(3,108) qup,qvp
 108  format(' net charge on solute and solvent', 2f10.4) 
      write(3,109) pmou, pmov
 109  format(' molecular weight, solute and solvent',/2x,2f10.4)
      sqpu=0.0
      sqmu=0.0
      do 7 j=1,nasolu
      quq=qq(j)
      if(quq.le.0.0) sqmu=sqmu+quq
      if(quq.gt.0.0) sqpu=sqpu+quq
   7  continue
      sqpv=0.0
      sqmv=0.0
      do 6 j=1,nasolv
      jp=j+nasolu
      quq=qq(jp)
      if(quq.le.0.0) sqmv=sqmv+quq
      if(quq.gt.0.0) sqpv=sqpv+quq
   6  continue
      write(3,11) sqpu,sqmu,sqpv,sqmv
  11  format(' sum of + and - charges, solute and solvent',
     1 /2x,2f10.4,2x,2f10.4)
      suto=abs(sqpu+sqmu+sqpv+sqmv)
      if(suto.gt.0.001) write(6,1777)
      if(suto.gt.0.001) write(3,1777)
 1777 format(//' *******warning, unbalanced charges detected***'/)
c --- read box file unit 4 -------------------------------------------
      nrepa=1
      nrepb=1
      nrepc=1
      call rebox (irbox,nvar,nvaru,nvarv,nparu,nparv,
     1 nrepa,nrepb,nrepc,icent)
      if(nmsolv.gt.mxsolv) call emerg (51)
      if(nmsolu.gt.mxsolu) call emerg(52)
      frepa=float(nrepa)
      frepb=float(nrepb)
      frepc=float(nrepc)
      twose=albox+bebox+gabox-270.0
      twose=abs(twose)
      small=0.1
c     isotropic control but oblique box
      if(ianis.eq.1.and.twose.gt.small) write(6,90)
      if(ianis.eq.3.and.twose.gt.small) write(6,90)
 90   format(' &&&&&&warning,isotropic box control but oblique box')
c     compute max box shifts for anisotropic box changes
      chax=float(abs(ibx))*0.01
      chay=float(abs(iby))*0.01
      chaz=float(abs(ibz))*0.01
c     set possible coupling of box changes 
      ichbox=1
      if(ibx.lt.0.and.iby.lt.0.and.ibz.gt.0) ichbox=2
      if(ibx.lt.0.and.iby.gt.0.and.ibz.lt.0) ichbox=3
      if(ibx.gt.0.and.iby.lt.0.and.ibz.lt.0) ichbox=4
      if(ibx.lt.0.and.iby.lt.0.and.ibz.lt.0) ichbox=5
      chaal=float(ial)*0.1
      chabe=float(ibe)*0.1
      chaga=float(iga)*0.1
      write(3,5) boxx,chax,boxy,chay,boxz,chaz,albox,
     1 chaal,bebox,chabe,gabox,chaga
 5    format(' box dimensions and max steps',/2x,6f8.4,6f7.2)
      if(nasolu.gt.mxatu) call emerg(1)
      if(nasolv.gt.mxatv) call emerg(1)
      if(ncardu.gt.(mxatu-3)) call emerg(2)
      if(ncardv.gt.(mxatv-3)) call emerg(2)
      if(nvar.gt.maxpar) call emerg(3)
      nmtot=nmsolu+nmsolv
c     establish number of particles for IIE pressure control
c     this is the total number of molecules (??) 
      fpartc=nmtot
      if(nmtot.gt.mxmol) call emerg(4)
      write(3,110) nmsolu,nasolu,nmsolv,nasolv
      write(3,111) nparu,nparv,nvar,nvaru,nvarv
 110  format(' N.solutes-atoms, N.solvents-atoms',/2x,4i6)
 111  format(' total parameters in solutes and solvents',2i6,
     1 /' actual variables, total,solute,solvent',3i6)
c     build starting atomic coordinates for all molecules in box ---
      do 120 i=1,nmtot
c     isolv=0 solute molecule, isolv=1 solvent molecule
      isolv=0
      ishat=0
      ishc=0
      ishmol=0
      ncards=ncardu
      natoms=nasolu
      if(i.le.nmsolu) go to 121
      isolv=1
      ishat=nasolu
      ishc=ncardu
      ishmol=nmsolu
      ncards=ncardv
      natoms=nasolv
c  --calculate slave atom positions
 121  continue
      call slaves (i,ishat,ishc,ishmol,ncards,natoms)
c  --check enantiomer
      ic=iabs(ichir(i))
      if(ic.eq.0) go to 122
      do 123 j=1,natoms
      jp=j+ishat
      if(ic.eq.1.or.ic.eq.4.or.ic.eq.5.or.ic.eq.7)
     1 xlab(jp,1)=-xlab(jp,1)
      if(ic.eq.2.or.ic.eq.4.or.ic.eq.6.or.ic.eq.7)
     1 xlab(jp,2)=-xlab(jp,2)
      if(ic.eq.3.or.ic.eq.5.or.ic.eq.6.or.ic.eq.7)
     1 xlab(jp,3)=-xlab(jp,3)
 123  continue
 122  continue
c  -------apply rotation
      call euler(i,natoms,ishat)
c  -------apply c.o.m. translation 
      do 124 j=1,natoms
      jp=j+ishat
      xf(i,j)=xlab(jp,1)+pvar(i,1)
      yf(i,j)=xlab(jp,2)+pvar(i,2)
 124  zf(i,j)=xlab(jp,3)+pvar(i,3)
 120  continue
c  --------------------------------------------------------
c     other preliminaries for MC calculation
c     refer whole box to global c.o.c if coc reset is required
      if(ncomc.ne.0) call cocres(0)
c     kbound.ne.0 box periodicity is present
      if(kbound.eq.0) go to  130
      call cocres (0)
      do 132 i=1,nmtot
      call boxch(i)
 132  continue
 130  continue
c     write on file mcc the first box in dat form only
      if(nwrite.gt.0) call writra (0,7,0,nvar,mxmol,
     1 nrepa,nrepb,nrepc,icent)
c     find sequence number of reference molecule in solute cluster
c     find molecule closest to cluster c.o.c., number is icent
      if(isymch.ne.0.and.icent.ne.0) go to 421
      cx=0.0
      cy=0.0
      cz=0.0
      fs=float(nmsolu)
      do 422 i=1,nmsolu
      cx=cx+pvar(i,1)
      cy=cy+pvar(i,2)
 422  cz=cz+pvar(i,3)
      cx=cx/fs
      cy=cy/fs
      cz=cz/fs
      rmin=10000.0
      do 423 i=1,nmsolu
      rab=(pvar(i,1)-cx)**2+(pvar(i,2)-cy)**2+(pvar(i,3)-cz)**2
      if(rab.gt.rmin) go to 423
      rmin=rab
      icent=i
 423  continue
 421  write(3,424) icent,(pvar(icent,k),k=1,3)
 424  format(' central solute molecule is n. ',i5,3f10.4)
      do 430 i=1,nasolu
      ispe=isp(i)
      write(3,431) i,symbol(ispe),xf(icent,i),yf(icent,i),zf(icent,i),
     1 ispe,qq(i) 
 431  format(i5,2x,a2,3f10.4,i5,f10.4) 
 430  continue
      if(isymch.eq.0) icent=0
c--------------------------------------------------------------------
c     section II
 2001 continue
c     initialize acceptance ratio counts, general steps
      ngent=0
      nacce=0
      nreje=0
c     initialize box acceptance counts
      nvarbo=0
      naccbo=0
      nrejbo=0
c     compute initial energies -----------------------
      fmsolu=float(nmsolu)
      fasolu=float(nasolu)
      mxpar=20000
      do 201 i=1,mxpar
 201  kvc(i)=0
c     compute initial intramolecular energy
      write(3,202)
 202  format(' computing intramolecular energies')
      einu=0.0
      einv=0.0
      do 203 i=1,nmtot
      call eintra (i,estr,ebend,etors,enonb)
      sum=estr+ebend+etors+enonb*factin
      sabs=abs(sum)
      small=0.001
      if(ipri.gt.1.and.sabs.gt.small)
     1 write(3,204) i,estr,ebend,etors,enonb,sum
 204  format('  mol., Es,Eb,Et,Enb,Tot',i6,5f10.2)
      if(i.gt.nmsolu) go to 206
      ebondu(i)=sum
      einu=einu+sum
      go to 203
 206  ebondv(i)=sum
      einv=einv+sum
 203  continue
      eintrz=einu+einv
      write(3,205) einu,einv,eintrz
 205  format(' solute, solvent, tot intramolecular energy', 3f10.1)
c     compute initial intermolecular non-bonded energy 
      uulpez=0.0
      uuqez=0.0
      vvlpez=0.0
      vvqez=0.0
      uvlpez=0.0
      uvqez=0.0
c     compute initial intermolecular energy, 
c     save initial energy configuration
      do 207 i=1,nmsolu
      call einter(i)
      do 207 j=1,nmsolu
      elpu(i,j)=ulp(j)
      equ(i,j)=uq(j)
      if(j.gt.i) go to 207
      uulpez=uulpez+ulp(j)
      uuqez=uuqez+uq(j)
 207  continue
      if(nmsolv.eq.0) go to 211
      do 208 i=1,nmsolv
      ip=i+nmsolu
      call einter(ip)
      do 209 j=1,nmsolv
      elpv(i,j)=vlp(j)
      eqv(i,j)=vq(j)
      if(j.gt.i) go to 209
      vvlpez=vvlpez+vlp(j)
      vvqez=vvqez+vq(j)
 209  continue
      do 210 j=1,nmsolu
      elpuv(j,i)=uvlp(j)
      equv(j,i)=uvq(j)
      uvlpez=uvlpez+uvlp(j)
 210  uvqez=uvqez+uvq(j)
 208  continue
 211  continue
      elpz=uulpez+vvlpez+uvlpez
      eqz=uuqez+vvqez+uvqez
c     compute box dipole energy if ianis = 3 (anisotropic box)
      eboxz=0.0
      if(iboxdi.eq.1) call dipbox(-1,eboxz)
      eqz=eqz+eboxz
      ezero=eintrz+elpz+eqz
      write(3,220)
  220 format(/' Intermolecular energies')
      write(3,221) uulpez,vvlpez,uvlpez
      write(3,222) uuqez,vvqez,uvqez
      write(3,223) elpz,eqz,ezero
  221 format('   LP energies, u,v,uv',3f10.2)
  222 format(' Coul energies, u,v,uv',3f10.2)
  223 format(' Total LP,Coul,total E',3f10.2)
      write(3,224) eboxz
  224 format('   box dipole energy  ',f10.2)
c     check initial symmetry -------------------------------
      if(isymch.eq.0) go to 231
      write(3,253) isy1,isy2,tolsy,cutsy
 253  format(/2x,' ------- biasing parameters --------',
     1 /2x,' sym fom indicators,,tol,cutoff ',2x,2i4,d14.2,f7.2)
      if(nexcs.ne.0) write(3,257) (nex(i),i=1,nexcs)
 257  format(' atoms excluded from sym fom calcn.',10i4)
c     prepare tables for atoms excluded from symfom
      wet=pmou
      do 236 i=1,nasolu
      wesy(i)=ww(i)
 236  nosy(i)=0
      if(nexcs.eq.0) go to 238
      wet=0.0
      do 237 i=1,nexcs
      j=nex(i)
 237  nosy(j)=1
      k=0
      do 239 i=1,nasolu
      if(nosy(i).ne.0) go to 239
      k=k+1
      wesy(k)=ww(i)
      wet=wet+ww(i)
 239  continue
 238  nasy=nasolu-nexcs
c     now compute starting f.o.m. 
      call symche (icent,isy1,isy2,symzer)
      write(3,235) symzer
      write(6,235) symzer 
 235  format(/' Starting symmetry f.o.m',d14.6)
      if(kbound.eq.1.and.isymch.lt.0) write(3,1494)
      if(kbound.eq.1.and.isymch.lt.0) write(6,1494)
 1494 format(' +++++warning,condens.bias may fail with periodic box ')
 231  continue
c     output energy trajectory
      if(ne.gt.0) call writen (0,pmou,pmov)
c     output parameters before actual MC steps --------------------
      if(nvar.le.0) call emerg(12)
      arand=0.0
      att=boxx/frepa
      btt=boxy/frepb
      ctt=boxz/frepc
      write(3,261) frepa,frepb,frepc
 261  format(' multiples of box dim',/2x,3f8.1)
      write(3,240)
      write(6,240)
      write(3,241) eintrz,elpz,eqz,eboxz,ezero,att,btt,ctt,
     1albox,bebox,gabox
      write(6,241) eintrz,elpz,eqz,eboxz,ezero,att,btt,ctt,
     1albox,bebox,gabox
 240  format(/' Eintra,Elp,Eq,Edip,Et,box,initial values')
 241  format(1x,5f9.1,3f8.4,3f8.2)
c     total cohesive energy per molecule
      fost=float(nmsolu+nmsolv)
      ecoh=(elpz+eqz)/fost
      femo=ezero/fost
c     initial box volume and overall density
      pz=0.0174533
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vbox=sqrt(vabc)*boxx*boxy*boxz
      totwe=float(nmsolu)*pmou+float(nmsolv)*pmov
      dens=0.0
      if(vbox.lt.0.1) go to 530
      dens=totwe*1.6606/vbox
 530  write(3,525) ecoh,femo,vbox,dens
      write(6,525) ecoh,femo,vbox,dens
 525  format(' Ecoh,Et per mol.,vbox,dens,initial values',
     1 /2x,2f8.1,f10.2,f8.3)
c     initialize random number generator
      call random_number (ar)
      if(nmomax.eq.0) stop
      write(3,242) ftemp,nmomax,nboxc,ncomc,nwrite,ne
 242  format(/' Temperature,n.moves,nboxc,ncomc,nwribox,nwrie',
     1 /1x,f10.2,5i10) 
      write(3,243) (pstep(k),k=1,5)
 243  format(' MC steps  ',/1x,5f6.2)
      write(3,245) nboxc,npres,ianis,presat
      pres= presat*101300.0
 245  format(' box control, P control, ianis ',2i6,i4,' set P ',f6.1)
      if(ftemp.eq.0.0) call emerg (54) 
      tefac=1000.0/(8.314*ftemp)
c     nmove is the total steps counter (general E plus box)
      nmove=0
      write(3,280)
 280  format(/1x,'MC moves initial ')
c--------------------------------------------------------------------
c     section III
c     start MC steps : preliminaries------------------------
 3001 continue
      nmove=nmove+1
c     stop c.o.c. drift if required
      if(ncomc.eq.0) go to 301
      mcoc=mod(nmove,ncomc)
      if(mcoc.eq.0) call cocres(nmove)
 301  continue
c     box dimensions change section-------------------------
c     with or without IIE P control 
c     no box change, no P control
      if(nboxc.eq.0.and.npres.eq.0) go to 350
c     check Nmove if pressure control or box change required
      if(nboxc.ne.0) mboc=mod(nmove,nboxc)
      if(npres.ne.0) mboc=mod(nmove,npres)
      if(mboc.ne.0) go to 350
      nvarbo=nvarbo+1
c     save entire box in case move is not accepted
      do 351 i=1,nmtot
      savep(i,1)=pvar(i,1)
      savep(i,2)=pvar(i,2)
      savep(i,3)=pvar(i,3)
      na=nasolu
      if(i.gt.nmsolu) na=nasolv
      do 351 j=1,na
      xusav(i,j)=xf(i,j)
      yusav(i,j)=yf(i,j)
 351  zusav(i,j)=zf(i,j)
      savebx=boxx
      saveby=boxy
      savebz=boxz
      saveal=albox
      savebe=bebox
      savega=gabox
c     apply box dimension shift
      if(ianis.eq. 2) go to 313
c     isotropic change
      call random_number (ara)
      arame=ara-0.5
      chiso=1.0+float(ibx)*0.01*arame
      boxx=boxx*chiso
      boxy=boxy*chiso
      boxz=boxz*chiso
      go to 314
c     anisotropic change
 313  continue
      call random_number (ara)
      charm1=chax*(ara-0.5)
      call random_number (ara)
      charm2=chay*(ara-0.5)
      call random_number (ara)
      charm3=chaz*(ara-0.5)
c     see for possible coupling among a,b,c cell edges
      go to (322,316,317,318,319), ichbox
 322  boxx=boxx+charm1
      boxy=boxy+charm2
      boxz=boxz+charm3
      go to 321
c     change a=b
 316  boxx=boxx+charm1
      boxy=boxy+charm1
      boxz=boxz+charm3
      go to 321
c     change a=c
 317  boxx=boxx+charm1
      boxy=boxy+charm2
      boxz=boxz+charm1
      go to 321
c     change b=c
 318  boxx=boxx+charm1
      boxy=boxy+charm2
      boxz=boxz+charm2
      go to 321
c     change a=b=c
 319  boxx=boxx+charm1
      boxy=boxy+charm1
      boxz=boxz+charm1
 321  continue 
c     anisotropic change of cell angles
      call random_number (ara)
      arame=ara-0.5
      albox=albox+chaal*arame
      call random_number (ara)
      arame=ara-0.5
      bebox=bebox+chabe*arame
      call random_number (ara)
      arame=ara-0.5
      gabox=gabox+chaga*arame
 314  continue
c     implement box dimension changes
      call boxexp (savebx,saveby,savebz,saveal,savebe,savega,vold,vnew)
c     recalculate full intermolecular energy
      uutry=0.0
      uuqtry=0.0
      vvtry=0.0
      vvqtry=0.0
      uvtry=0.0
      uvqtry=0.0
      do 352 i=1,nmsolu
      call einter(i)
      do 352 j=1,nmsolu
      if(j.gt.i) go to 352 
      uutry=uutry+ulp(j)
      uuqtry=uuqtry+uq(j)
 352  continue
      if(nmsolv.eq.0) go to 353 
      do 354 i=1,nmsolv
      ip=i+nmsolu
      call einter(ip)
      do 355 j=1,nmsolv
      if(j.gt.i) go to 355 
      vvtry=vvtry+vlp(j)
      vvqtry=vvqtry+vq(j)
 355  continue
      do 356 j=1,nmsolu
      uvtry=uvtry+uvlp(j)
 356  uvqtry=uvqtry+uvq(j)
 354  continue
 353  elptry=uutry+vvtry+uvtry
      eqtry=uuqtry+vvqtry+uvqtry
c     compute box dipole energy 
      eboxtr=0.0
      if(iboxdi.eq.1) call dipbox(-1,eboxtr)
      eqtry=eqtry+eboxtr
      tottry=eintrz+elptry+eqtry
      delu=tottry-ezero
      delh=delu
      avog=6.02214e+23
      deluj=delu*1000.0/avog
c     if npres=0 no P control, box change only
      if(npres.eq.0) go to 315
c     compute volume change contributions to del(H)
c     isotropic-isobaric ensemble IIE
c     Allen & Tildesley eq. 4.32 p.124
      delvo=vnew-vold
c     rescale to kJ and avogadro's number
      fresc=avog/1000.0
c     pres is set pressure in N m-2
      work=fresc*pres*delvo*1.0e-30
      boltz=1.38066d-23
      flov=log(vnew/vold)
      wght=fresc*fpartc*boltz*ftemp*flov
      delh=delu+work-wght
c     acceptance tests, if energy decrease, box change accepted
 315  continue
      if(delh.lt.0.0) go to 360
c     Metropolis algorithm
      espo=delh*tefac
      if(espo.gt.10.0) espo=20.0
      dex=exp(-espo)
      call random_number(ara)
      if(dex.gt.ara) go to 360
c     box change not accepted, restore old box
      nrejbo=nrejbo+1
      do 361 i=1,nmtot
      pvar(i,1)=savep(i,1)
      pvar(i,2)=savep(i,2)
      pvar(i,3)=savep(i,3)
      na=nasolu
      if(i.gt.nmsolu) na=nasolv
      do 361 j=1,na
      xf(i,j)=xusav(i,j)
      yf(i,j)=yusav(i,j)
 361  zf(i,j)=zusav(i,j)
      boxx=savebx
      boxy=saveby
      boxz=savebz
      albox=saveal
      bebox=savebe
      gabox=savega
c     re-compute old box dipoles   
      eboxz=0.0
      if(iboxdi.eq.1) call dipbox(-1,eboxz)
      go to 4001
c     box change accepted, insert new energies
 360  naccbo=naccbo+1
      ezero=tottry
      elpz=elptry
      eboxz=eboxtr
      eqz=eqtry
      uulpez=uutry
      uuqez=uuqtry
      uvlpez=uvtry
      uvqez=uvqtry
      vvlpez=vvtry
      vvqez=vvqtry
      do 363 i=1,nmsolu
      call einter(i)
      do 363 j=1,nmsolu
      elpu(i,j)=ulp(j)
      equ(i,j)=uq(j)
 363  continue
      if(nmsolv.eq.0) go to 364 
      do 365 i=1,nmsolv
      ip=i+nmsolu
      call einter(ip)
      do 366 j=1,nmsolv
      elpv(i,j)=vlp(j)
      eqv(i,j)=vq(j)
 366  continue
      do 367 j=1,nmsolu
      elpuv(j,i)=uvlp(j)
      equv(j,i)=uvq(j)
 367  continue
 365  continue
 364  continue
      write(3,368) nmove,boxx,boxy,boxz,albox,bebox,gabox,presat
      write(6,368) nmove,boxx,boxy,boxz,albox,bebox,gabox,presat
 368  format(1x,i10,6f9.3,f9.0,' box data')
c     end of box change section------------------------------------
      go to 4001
c     ordinary MC step on molecular parameters---------------------
c     change parameter n. npr of molecule n. nmolv
 350  continue
c     counter of ordinary MC steps
      ngent=ngent+1
      call random_number (ar)
      nrand=ar*nvar+1.0
      if(nrand.gt.nvar) nrand=nvar
c     kvc is the counter for statistics on distribution of MC steps
      kvc(nrand)=kvc(nrand)+1
      nmolv=kv(nrand,1)
      isolv=0
      ishat=0
      ishc=0
      ishmol=0
      ncards=ncardu
      natoms=nasolu
      if(nmolv.le.nmsolu) go to 341
      nmolvv=nmolv-nmsolu
      isolv=1
      ishat=nasolu
      ishc=ncardu
      ishmol=nmsolu
      ncards=ncardv
      natoms=nasolv
 341  npr=kv(nrand,2)
      kv3=kv(nrand,3)
      step=pstep(kv3)
c     save parameter and coordinates in case step is not accepted
      do 342 kk=1,3
 342  savet(kk)=pvar(nmolv,kk)
      psav=pvar(nmolv,npr)
      do 343 i=1,natoms
      savef(i,1)=xf(nmolv,i)
      savef(i,2)=yf(nmolv,i)
 343  savef(i,3)=zf(nmolv,i)
c     apply MC shift --------------------------------------------
      call random_number (arand)
      pvar(nmolv,npr)=pvar(nmolv,npr)+(arand-0.5)*step
c     then change coordinates of one molecule
      call slaves (nmolv,ishat,ishc,ishmol,ncards,natoms)
c     check chirality index
      ic=ichir(nmolv)
      if(ic.eq.0) go to 344
      do 345 j=1,natoms
      jp=j+ishat
      if(ic.eq.1.or.ic.eq.4.or.ic.eq.5.or.ic.eq.7)
     1 xlab(jp,1)=-xlab(jp,1)
      if(ic.eq.2.or.ic.eq.4.or.ic.eq.6.or.ic.eq.7)
     1 xlab(jp,2)=-xlab(jp,2)
      if(ic.eq.3.or.ic.eq.5.or.ic.eq.6.or.ic.eq.7)
     1 xlab(jp,3)=-xlab(jp,3)
 345  continue
 344  continue
c     apply rotation
      call euler(nmolv,natoms,ishat)
c     apply c.o.m. translation
      do 346 j=1,natoms
      jp=j+ishat
      xf(nmolv,j)=xlab(jp,1)+pvar(nmolv,1)
      yf(nmolv,j)=xlab(jp,2)+pvar(nmolv,2)
 346  zf(nmolv,j)=xlab(jp,3)+pvar(nmolv,3)
      if(kbound.ne.0) call boxch(nmolv)
c     optional: -----check symmetries after step ---------------------
      if(isolv.eq.1.or.isymch.eq.0) go to 347
      call symche (icent,isy1,isy2,symtry)
      delsy=symtry-symzer
c     symmetry-delta increase g> tolerance step rejected
      if(delsy.gt.tolsy) go to 401
 347  continue
c     compute intramolecular and intermolecular energy
      if(isolv.eq.0) eme=ebondu(nmolv)
      if(isolv.eq.1) eme=ebondv(nmolv) 
      call eintra (nmolv,estr,ebend,etors,enonb)
      sum=estr+ebend+etors+enonb*factin
      eintry=eintrz-eme+sum
c     new einter after single move
      call einter (nmolv)
c     compute box dipole energy 
      eboxtr=0.0
      if(iboxdi.eq.1) call dipbox(nmolv,eboxtr)
      deleuu=0.0
      delquu=0.0
      deleuv=0.0
      delquv=0.0
      delevv=0.0
      delqvv=0.0
c     isolv=0 solute, isolv=1 solvent molecule
      if(isolv.eq.1) go to 370
c     delta E solute-solute
      do 371 ktry=1,nmsolu
      deleuu=deleuu-elpu(nmolv,ktry)+ulp(ktry)
 371  delquu=delquu-equ(nmolv,ktry)+uq(ktry)
      go to 373
c     delta E solvent-solvent
 370  do 374 ktry=1,nmsolv
      delevv=delevv-elpv(nmolvv,ktry)+vlp(ktry)
 374  delqvv=delqvv-eqv(nmolvv,ktry)+vq(ktry)
 373  if(nmsolv.eq.0) go to 375
      if(isolv.eq.0) go to 376
c     delta E solvent-solute
      do 377 ktry=1,nmsolu
      deleuv=deleuv-elpuv(ktry,nmolvv)+uvlp(ktry)
 377  delquv=delquv-equv(ktry,nmolvv)+uvq(ktry)
      go to 375
c     delta E solute-solvent
 376  do 378 ktry=1,nmsolv
      deleuv=deleuv-elpuv(nmolv,ktry)+uvlp(ktry)
 378  delquv=delquv-equv(nmolv,ktry)+uvq(ktry)
 375  delp=deleuu+delevv+deleuv
      delq=delquu+delqvv+delquv
      uulptr=uulpez+deleuu
      uuqtr=uuqez+delquu
      vvlptr=vvlpez+delevv
      vvqtr=vvqez+delqvv
      uvlptr=uvlpez+deleuv
      uvqtr=uvqez+delquv
      elptry=elpz+delp
      eqtry=eqz+delq
c     change in box dipole energy
      eqtry=eqtry-eboxz+eboxtr
      tottry=eintry+elptry+eqtry
c     energy decrease, step accepted
      iacc=0
      if(tottry.lt.ezero) go to 380
c     Metropolis algorithm
      call random_number (are)
      espo=(tottry-ezero)*tefac
      if(espo.gt.20.0) espo=20.0
      dex=exp(-espo)
      if(dex.lt.are)  go to 401
c     MC step is accepted ---------------------------------------
  380 nacce=nacce+1
      iacc=1
      ezero=tottry
      elpz=elptry
      eqz=eqtry
      eboxz=eboxtr
      uulpez=uulptr
      uvlpez=uvlptr
      vvlpez=vvlptr
      uuqez=uuqtr
      uvqez=uvqtr
      vvqez=vvqtr
      eintrz=eintry
      if(isolv.eq.0.and.isymch.ne.0) symzer=symtry
      if(isolv.eq.0) ebondu(nmolv)=sum
      if(isolv.eq.1) ebondv(nmolv)=sum
      if(isolv.eq.1) go to 381
      do 382 ktry=1,nmsolu
      elpu(nmolv,ktry)=ulp(ktry)
      elpu(ktry,nmolv)=ulp(ktry)
      equ(nmolv,ktry)=uq(ktry)
      equ(ktry,nmolv)=uq(ktry)
 382  continue
      go to 383
 381  do 384 ktry=1,nmsolv
      elpv(nmolvv,ktry)=vlp(ktry)
      elpv(ktry,nmolvv)=vlp(ktry)
      eqv(nmolvv,ktry)=vq(ktry)
 384  eqv(ktry,nmolvv)=vq(ktry)
 383  if(nmsolv.eq.0) go to 385
      if(isolv.eq.0) go to 386
c     solvent-solute
      do 387 ktry=1,nmsolu
      elpuv(ktry,nmolvv)=uvlp(ktry)
 387  equv(ktry,nmolvv)=uvq(ktry)
      go to 385
c     solute-solvent
 386  do 388 ktry=1,nmsolv
      elpuv(nmolv,ktry)=uvlp(ktry)
 388  equv(nmolv,ktry)=uvq(ktry)
 385  continue
      go to 4001
c     ----------------------------------------------------
c     step is not accepted, restore parameter
  401 continue
      nreje=nreje+1
      pvar(nmolv,npr)=psav
      do 403 kk=1,3
 403  pvar(nmolv,kk)=savet(kk)
c     restore saved coordinates
      do 404 i=1,natoms
      xf(nmolv,i)=savef(i,1)
      yf(nmolv,i)=savef(i,2)
 404  zf(nmolv,i)=savef(i,3)
      eboxz=0.0
      if(iboxdi.eq.1) call dipbox(nmolv,eboxz)
c     ---------------------------------------------------------
c     final point of all possible MC steps
 4001 continue
      att=boxx/frepa
      btt=boxy/frepb
      ctt=boxz/frepc
      if(npri.eq.0) go to 390
      mcoc=mod(nmove,npri)
      if(mcoc.ne.0) go to 390
      write(3,389) nmove,eintrz,elpz,eqz,eboxz,ezero,symzer
      write(3,391) uulpez,uvlpez,vvlpez,uuqez,uvqez,vvqez
 391  format(1x,8f9.1)
      write(6,389) nmove,eintrz,elpz,eqz,eboxz,ezero,symzer
 389  format(1x,i10,5f9.1,f10.4,' ens data')
 390  continue
c     write geometry dat trajectory
      movm=1
      if(nwrite.gt.0) movm=mod(nmove,nwrite)
      if(movm.eq.0) call writra (nmove,7,0,nvar,mxmol,
     1 nrepa,nrepb,nrepc,icent)
c     write energy trajectory
      movm=1
      if(ne.gt.0) movm=mod(nmove,ne)
      if(movm.eq.0) call writen (nmove,pmou,pmov)
c     branch back to next step
      if(nmove.lt.nmomax) go to 3001
c
c     -------end of MC steps--------------------------------------
c
      write(3,501) nmove
 501  format(/' last step '/1x,i10)
      write(3,521) ngent,nacce,nreje,nvarbo,naccbo,nrejbo
 521  format(' general,tot,acc,rej,  box,tot,acc,rej',/2x,6i10)
      fmoto=nacce+nreje
      fmobo=naccbo+nrejbo
      accra=100.0*float(nacce)/fmoto
      accrbo=0.0
      if(nvarbo.ne.0) accrbo=100.0*float(naccbo)/fmobo
      write(3,512) (head2(kg),kg=1,5),accra,accrbo
 512  format(1x,5a2,' acceptance ratio, total,box ',2f10.2)
      att=boxx/frepa
      btt=boxy/frepb
      ctt=boxz/frepc
c     output final parameters
      write(3,502)
  502 format(/' last MC step,Eintr,Elp,Eq,Edip,Etot,Sym as ')
      write(3,503) eintrz,elpz,eqz,eboxz,ezero,symzer
      write(3,504) att,btt,ctt,albox,bebox,gabox
 503  format(1x,5f9.1,f10.5 )
 504  format(1x,3f8.4,3f8.2)
      write(6,502)
      write(6,503) eintrz,elpz,eqz,eboxz,ezero,symzer
      write(6,504) att,btt,ctt,albox,bebox,gabox
c     output final energies partitioned between solute and solvent
      write(3,220)
      write(3,221) uulpez,vvlpez,uvlpez
      write(3,222) uuqez,vvqez,uvqez
      write(3,223) elpz,eqz,ezero
      write(3,224) eboxz
c     total cohesive energy per molecule
      fost=float(nmsolu+nmsolv)
      ecoh=(elpz+eqz)/fost
      femo=ezero/fost
c     final box volume and overall density
      pz=0.0174533
      cali=cos(albox*pz)
      cbei=cos(bebox*pz)
      cgai=cos(gabox*pz)
      sgai=sin(gabox*pz)
      vabc=1.0-cali**2-cbei**2-cgai**2+2.0*cali*cbei*cgai
      vbox=sqrt(vabc)*boxx*boxy*boxz
      totwe=float(nmsolu)*pmou+float(nmsolv)*pmov
      dens=0.0
      if(vbox.lt.0.1) go to 510
      dens=totwe*1.6606/vbox
 510  write(3,505) (head2(kg),kg=1,5),ecoh,femo,vbox,dens
      write(6,505) (head2(kg),kg=1,5),ecoh,femo,vbox,dens
 505  format(/1x,5a2,' final Ecoh,Et per mol.,vbox,dens',
     1 2f8.1,f10.2,f8.3)
      if(ipri.eq.0) go to 507
      write(3,508)
 508  format(' distribution of steps over parameters')
      write(3,509) (kvc(kk),kk=1,nvar)
 509  format(20i4)
 507  continue
c     output final geometry frame on files mco and mcc
      call writra (nmove,9,8,nvar,mxmol,nrepa,nrepb,nrepc,icent)
      if(nwrite.gt.0) call writra (nmove,7,0,nvar,mxmol,
     1 nrepa,nrepb,nrepc,icent)
c     output final energy frame
      if(ne.gt.0) call writen (nmove,pmou,pmov)
      stop
      end
