c
      subroutine symche (icent,isy1,isy2,symfom)
c     -------------------------------------------------------
c     version with alternate fom's according to ichir
c     
c     also includes option for condensation bias 
c
c     april 20 2021
c     -------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
      dimension xce(100,3),xjm(100,3),r(3,3),rv(3,3),xfa(100,3),
     1 xfb(100,3),xac(100,3),xbc(100,3),fom(8) 
      common /num/ nasolu,nmsolu,ncoreu,ncardu,nslavu,
     1 nasolv,nmsolv,ncorev,ncardv,nslavv
      common /flo/ xlab(200,3),xcore(200,3),ww(200),
     1 qq(200),xf(4000,100),yf(4000,100),zf(4000,100)
c     nosy =0 include, =1 do not include atom in symfom calcn. 
c     nasy  number of included natoms
      common /symch/ tolsy,cutsy,wesy(100),wet,nosy(100),nasy
      common /var/ pvar(4000,150),kv(20000,3),npar
      common /int/ichir(4000),islav(200,6),isp(200),ipots,ipri
c     if isy1 < 0 go to condensation bias section
      if(isy1.lt.0) go to 300
c     symmetry bias section -----------------------------------------
c     save coords of molecule icent in xce and set its c.o.c.,cx,cy,cz
      cx=0.0
      cy=0.0
      cz=0.0
      fs=float(nasy)
      i=0
c     find c.o.c. of central molecule coords in xce(100,3) 
      do 14 j=1,nasolu
      if(nosy(j).ne.0) go to 14
      i=i+1
      xce(i,1)=xf(icent,i)
      xce(i,2)=yf(icent,i)
      xce(i,3)=zf(icent,i)
      cx=cx+xce(i,1)
      cy=cy+xce(i,2)
      cz=cz+xce(i,3)
 14   continue
      cx=cx/fs
      cy=cy/fs
      cz=cz/fs
c     refer central molecule to its c.o.c. cx,cy,cz 
      do 15 i=1,nasy
      xce(i,1)=xce(i,1)-cx
      xce(i,2)=xce(i,2)-cy
 15   xce(i,3)=xce(i,3)-cz
c     open main loop on surrounding molecules------------
c     contc is number of molecule-molecule contacts to central 
      contc=0.0
c     symfom is the response function 
      symfom=0.0
      do 100 jm=1,nmsolu
      if(icent.eq.jm) go to 100
c     save coords of molecule jm in xjm referred to its c.o.c. 
c     and set its c.o.c.,cxj,cyj,czj
      cxj=0.0
      cyj=0.0
      czj=0.0
      i=0
      do 19 j=1,nasolu
      if(nosy(j).ne.0) go to 19
      i=i+1
      xjm(i,1)=xf(jm,j)
      xjm(i,2)=yf(jm,j)
      xjm(i,3)=zf(jm,j)
      cxj=cxj+xjm(i,1)
      cyj=cyj+xjm(i,2)
      czj=czj+xjm(i,3)
 19   continue
      cxj=cxj/fs
      cyj=cyj/fs
      czj=czj/fs
c     screen out distances > cutsy
      rab=(cx-cxj)**2+(cy-cyj)**2+(cz-czj)**2
      rab=sqrt(rab)
      if(rab.gt.cutsy) go to 100
c     valid contact proceed to foms
      contc=contc+1.0
      do 20 i=1,nasy
      xjm(i,1)=xjm(i,1)-cxj
      xjm(i,2)=xjm(i,2)-cyj
 20   xjm(i,3)=xjm(i,3)-czj
c     compute center of mass and inertial coordinates 
c     of dimer between molecule icent and molecule jm 
      comx=0.0
      comy=0.0
      comz=0.0
      we2=2.0*wet
      do 21 i=1,nasy
      wi=wesy(i)
      comx=comx+(xce(i,1)+xjm(i,1))*wi
      comy=comy+(xce(i,2)+xjm(i,2))*wi
 21   comz=comz+(xce(i,3)+xjm(i,3))*wi
c     refer to center of mass and fill inertial matrix
c     xfa and xfb are coords of two molecules in common c.o.m.
      comx=comx/we2
      comy=comy/we2
      comz=comz/we2
      do 22 i=1,nasy
      xfa(i,1)=xce(i,1)-comx
      xfa(i,2)=xce(i,2)-comy
      xfa(i,3)=xce(i,3)-comz
      xfb(i,1)=xjm(i,1)-comx
      xfb(i,2)=xjm(i,2)-comy
 22   xfb(i,3)=xjm(i,3)-comz
      do 23 m=1,3
      do 23 n=1,3
 23   r(m,n)=0.0
c     fill inertial matrix 
      do 24 i=1,nasy
      ps=wesy(i)
      r(1,1)=r(1,1)+ps*(xfa(i,2)**2+xfa(i,3)**2)                                 
      r(2,2)=r(2,2)+ps*(xfa(i,1)**2+xfa(i,3)**2)                                
      r(3,3)=r(3,3)+ps*(xfa(i,1)**2+xfa(i,2)**2)                                
      r(1,2)=r(1,2)-ps*xfa(i,1)*xfa(i,2)                                        
      r(1,3)=r(1,3)-ps*xfa(i,1)*xfa(i,3)                                        
      r(2,3)=r(2,3)-ps*xfa(i,2)*xfa(i,3)                                        
      r(1,1)=r(1,1)+ps*(xfb(i,2)**2+xfb(i,3)**2)
      r(2,2)=r(2,2)+ps*(xfb(i,1)**2+xfb(i,3)**2)                                
      r(3,3)=r(3,3)+ps*(xfb(i,1)**2+xfb(i,2)**2)                                
      r(1,2)=r(1,2)-ps*xfb(i,1)*xfb(i,2)                                        
      r(1,3)=r(1,3)-ps*xfb(i,1)*xfb(i,3)                                        
 24   r(2,3)=r(2,3)-ps*xfb(i,2)*xfb(i,3)   
      r(2,1)=r(1,2)                                                   
      r(3,1)=r(1,3)                                                   
      r(3,2)=r(2,3)
      call jacob (r,rv)
c     xac and xbc have the coordinates of dimer in ref system
c     of the common center of mass   
      do 25 i=1,nasy
      xac(i,1)=rv(1,1)*xfa(i,1)+rv(1,2)*xfa(i,2)+rv(1,3)*xfa(i,3)
      xbc(i,1)=rv(1,1)*xfb(i,1)+rv(1,2)*xfb(i,2)+rv(1,3)*xfb(i,3)
      xac(i,2)=rv(2,1)*xfa(i,1)+rv(2,2)*xfa(i,2)+rv(2,3)*xfa(i,3)
      xbc(i,2)=rv(2,1)*xfb(i,1)+rv(2,2)*xfb(i,2)+rv(2,3)*xfb(i,3)
      xac(i,3)=rv(3,1)*xfa(i,1)+rv(3,2)*xfa(i,2)+rv(3,3)*xfa(i,3)
      xbc(i,3)=rv(3,1)*xfb(i,1)+rv(3,2)*xfb(i,2)+rv(3,3)*xfb(i,3)
  25  continue
c     compute discrepancy indices x/-x,y/-y,z/-z -----------------
      avxp=0.0
      avxm=0.0
      avyp=0.0
      avym=0.0
      avzp=0.0
      avzm=0.0
      do 31 i=1,nasy
      avxp=avxp+(xac(i,1)+xbc(i,1))**2
      avxm=avxm+(xac(i,1)-xbc(i,1))**2
      avyp=avyp+(xac(i,2)+xbc(i,2))**2
      avym=avym+(xac(i,2)-xbc(i,2))**2
      avzp=avzp+(xac(i,3)+xbc(i,3))**2
 31   avzm=avzm+(xac(i,3)-xbc(i,3))**2
      avxp=avxp/fs
      avxm=avxm/fs
      avyp=avyp/fs
      avym=avym/fs
      avzp=avzp/fs
      avzm=avzm/fs
c     translational symmetry
      fom(1)=(avxm+avym+avzm)/3.0
c     inversion center symmetry 
      fom(2)=(avxp+avyp+avzp)/3.0
c     twofold symmetry
      fom(3)=(avxm+avyp+avzp)/3.0
      fom(4)=(avxp+avyp+avzm)/3.0
      fom(5)=(avxp+avym+avzp)/3.0
c     mirror symmetry
      fom(6)=(avxp+avym+avzm)/3.0
      fom(7)=(avxm+avym+avzp)/3.0
      fom(8)=(avxm+avyp+avzm)/3.0
c     select fom -----------------------------------
      if(isy2.ne.0) go to 101
      if(isy1.ne.0) go to 102
c     isy1=isy2=0, find minimum non-zero fom 
      fomnew=1000.0
      do 34 i=1,8
      if(fom(i).lt.0.1) go to 34
      if(fom(i).lt.fomnew) fomnew=fom(i)
 34   continue
      go to 200
c     isy1.ne.0, isy2 = 0 new fom is fom(isy1)
 102  fomnew=fom(isy1)
      go to 200
c     isy2.ne.0 double assignmentaccording to ichir 
c     ichir indicators must be set at boxliq stage 
 101  fomnew=fom(isy1)
      if(ichir(icent).ne.ichir(jm)) fomnew=fom(isy2)
c     sum foms
 200  symfom=symfom+fomnew
c     close main loop on molecules--------------------------
  100 continue
      symfom=symfom/contc 
      return
c     condensation bias function
 300  symfo=0.0
      fs=float(nmsolu)
      divi=fs*(fs-1.0)/2.0
      nms1=nmsolu-1
      do 301 i=1,nms1
      px=pvar(i,1)
      py=pvar(i,2)
      pz=pvar(I,3)
      ip=i+1
      do 301 j=ip,nmsolu
      rr=(px-pvar(j,1))**2+(py-pvar(j,2))**2+(pz-pvar(j,3))**2
 301  symfo=symfo+sqrt(rr)
      symfom=symfo/divi
      return
      end
 